/*******************************************************************************

NAME            rootComplexApi.c
VERSION         %version: 2 %
UPDATE DATE     %date_modified: Thu Oct 17 11:33:47 2013 %
PROGRAMMER      %created_by:    weberc %

        Copyright 2013 NetApp, Inc. All rights reserved.

*******************************************************************************/
#include <common.h>
#include "include/lsisas3108_common.h"
#include "rootComplexApi.h"

extern unsigned long do_go_exec (ulong (*entry)(int, char * const []), int argc, char * const argv[]);

char *caddr[10];
char *entry_point = stringify(LSISAS3108_STANDALONE_ENTRY);
unsigned int addr = (LSISAS3108_STANDALONE_ENTRY);
int lib_name = RC_LIB;

int pcieRciInitBoard(void)
{
    int ret_val;
    int func_name = RC_PCI_BOARD_INIT;

    caddr[0] = entry_point;
    caddr[1] = (char *)&lib_name;
    caddr[2] = (char *)&func_name;

    ret_val = do_go_exec((void *)addr, 3, caddr);

    return ret_val;
}

int pcieRciIsRootComplexEnabled(void)
{
    int ret_val;
    int func_name = RC_IS_ENABLED;

    caddr[0] = entry_point;
    caddr[1] = (char *)&lib_name;
    caddr[2] = (char *)&func_name;

    ret_val = do_go_exec((void *)addr, 3, caddr);

    return ret_val;
}

int pcieRciIsLinkUp(void)
{
    int ret_val;
    int func_name = RC_IS_LINK_UP;
    
    caddr[0] = entry_point;
    caddr[1] = (char *)&lib_name;
    caddr[2] = (char *)&func_name;
    
    ret_val = do_go_exec((void *)addr, 3, caddr);

    return ret_val;
}

int pcieRciPerformLinkWidthTraining(U8 Width)
{
    int ret_val;
    int func_name = RC_PERFORM_LINK_WIDTH_TRNG;
    
    caddr[0] = entry_point;
    caddr[1] = (char *)&lib_name;
    caddr[2] = (char *)&func_name;
    caddr[3] = (char *)&Width;
 
    ret_val = do_go_exec((void *)addr, 4, caddr);

    return ret_val;
}

int pcieRciPerformLinkSpeedTraining(U8 Speed)
{
    int ret_val;
    int func_name = RC_PERFORM_LINK_SPEED_TRNG;
    
    caddr[0] = entry_point;
    caddr[1] = (char *)&lib_name;
    caddr[2] = (char *)&func_name;
    caddr[3] = (char *)&Speed;

    ret_val = do_go_exec((void *)addr, 4, caddr);

    return ret_val;
}

int pcieRciConfigurePOM(PCIE_RC_CONFIG_POM_PARAMS *PtrPOMConfigParams)
{
    int ret_val;
    int func_name = RC_CONFIGURE_POM;
    
    caddr[0] = entry_point;
    caddr[1] = (char *)&lib_name;
    caddr[2] = (char *)&func_name;
    caddr[3] = (char *)PtrPOMConfigParams;

    ret_val = do_go_exec((void *)addr, 4, caddr);
    
    return ret_val;
}

int pcieRciConfigurePIM(PCIE_RC_CONFIG_PIM_PARAMS *PtrPIMConfigParams)
{
    int ret_val;
    int func_name = RC_CONFIGURE_PIM;
    
    caddr[0] = entry_point;
    caddr[1] = (char *)&lib_name;
    caddr[2] = (char *)&func_name;
    caddr[3] = (char *)PtrPIMConfigParams;

    ret_val = do_go_exec((void *)addr, 4, caddr);

    return ret_val;
}

void pcieRciEnableMsixCapability(void)
{
    int func_name = RC_ENABLE_MSIX;
    
    caddr[0] = entry_point;
    caddr[1] = (char *)&lib_name;
    caddr[2] = (char *)&func_name;
    
    do_go_exec((void *)addr, 3, caddr);
}

int pcieRciConfigureMSIX(U8 Bus, U8 Device, U8 Function, U8 Vector, PCIE_RC_MSIX_MESSAGE *PtrMsixMessage)
{
    int ret_val;
    int func_name = RC_CONFIGURE_MSIX;
    
    caddr[0] = entry_point;
    caddr[1] = (char *)&lib_name;
    caddr[2] = (char *) &func_name;
    caddr[3] = (char *)&Bus;
    caddr[4] = (char *)&Device;
    caddr[5] = (char *)&Function;
    caddr[6] = (char *)&Vector;
    caddr[7] = (char *)PtrMsixMessage;
    
    ret_val = do_go_exec((void *)addr, 8, caddr);

    return ret_val;
}

U8 pcieRciFindCapability(U8 Bus, U8 Device, U8 Function, U32 CapabilityId)
{
    U8 ret_val;
    int func_name = RC_FIND_CAPABILITY;
    
    caddr[0] = entry_point;
    caddr[1] = (char *)&lib_name;
    caddr[2] = (char *)&func_name;
    caddr[3] = (char *)&Bus;
    caddr[4] = (char *)&Device;
    caddr[5] = (char *)&Function;
    caddr[6] = (char *)&CapabilityId;

    ret_val = (U8)do_go_exec((void *)addr, 7, caddr);

    return ret_val;
}

int pcieRciCfgReadDword(U8 Bus, U8 Device, U8 Function, U32 Address, U32 *PtrData)
{
    int ret_val;
    int func_name = RC_CFG_READ_DWORD;
    
    caddr[0] = entry_point;
    caddr[1] = (char *)&lib_name;
    caddr[2] = (char *)&func_name;
    caddr[3] = (char *)&Bus;
    caddr[4] = (char *)&Device;
    caddr[5] = (char *)&Function;
    caddr[6] = (char *)&Address;
    caddr[7] = (char *)PtrData;
    
    ret_val = do_go_exec((void *)addr, 8, caddr);

    return ret_val;
}

int pcieRciCfgReadWord(U8 Bus, U8 Device, U8 Function, U32 Address, U16 *PtrData)
{
    int ret_val;
    int func_name = RC_CFG_READ_WORD;
    
    caddr[0] = entry_point;
    caddr[1] = (char *)&lib_name;
    caddr[2] = (char *)&func_name;
    caddr[3] = (char *)&Bus;
    caddr[4] = (char *)&Device;
    caddr[5] = (char *)&Function;
    caddr[6] = (char *)&Address;
    caddr[7] = (char *)PtrData;

    ret_val = do_go_exec((void *)addr, 8, caddr);

    return ret_val;
}

int pcieRciCfgReadByte(U8 Bus, U8 Device, U8 Function, U32 Address, U8 *PtrData)
{
    int ret_val;
    int func_name = RC_CFG_READ_BYTE;
    
    caddr[0] = entry_point;
    caddr[1] = (char *)&lib_name;
    caddr[2] = (char *)&func_name;
    caddr[3] = (char *)&Bus;
    caddr[4] = (char *)&Device;
    caddr[5] = (char *)&Function;
    caddr[6] = (char *)&Address;
    caddr[7] = (char *)PtrData;

    ret_val = do_go_exec((void *)addr, 8, caddr);

    return ret_val;
}

int pcieRciCfgWriteDword(U8 Bus, U8 Device, U8 Function, U32 Address, U32 Data)
{
    int ret_val;
    int func_name = RC_CFG_WRITE_DWORD;
    
    caddr[0] = entry_point;
    caddr[1] = (char *)&lib_name;
    caddr[2] = (char *)&func_name;
    caddr[3] = (char *)&Bus;
    caddr[4] = (char *)&Device;
    caddr[5] = (char *)&Function;
    caddr[6] = (char *)&Address;
    caddr[7] = (char *)&Data;

    ret_val = do_go_exec((void *)addr, 8, caddr);

    return ret_val;
}

int pcieRciCfgWriteWord(U8 Bus, U8 Device, U8 Function, U32 Address, U16 Data)
{
    int ret_val;
    int func_name = RC_CFG_WRITE_WORD;
    
    caddr[0] = entry_point;
    caddr[1] = (char *)&lib_name;
    caddr[2] = (char *)&func_name;
    caddr[3] = (char *)&Bus;
    caddr[4] = (char *)&Device;
    caddr[5] = (char *)&Function;
    caddr[6] = (char *)&Address;
    caddr[7] = (char *)&Data;
    
    ret_val = do_go_exec((void *)addr, 8, caddr);

    return ret_val;
}

int pcieRciCfgWriteByte(U8 Bus, U8 Device, U8 Function, U32 Address, U8 Data)
{
    int ret_val;
    int func_name = RC_CFG_WRITE_BYTE;
    
    caddr[0] = entry_point;
    caddr[1] = (char *)&lib_name;
    caddr[2] = (char *)&func_name;
    caddr[3] = (char *)&Bus;
    caddr[4] = (char *)&Device;
    caddr[5] = (char *)&Function;
    caddr[6] = (char *)&Address;
    caddr[7] = (char *)&Data;

    ret_val = do_go_exec((void *)addr, 8, caddr);

    return ret_val;
}

int pcieRciMemReadDword(U32 Address, U32 *Data)
{
    int ret_val;
    int func_name = RC_MEM_READ_DWORD;
    
    caddr[0] = entry_point;
    caddr[1] = (char *)&lib_name;
    caddr[2] = (char *)&func_name;
    caddr[3] = (char *)&Address;
    caddr[4] = (char *)Data;
 
    ret_val = do_go_exec((void *)addr, 5, caddr);

    return ret_val;
}

int pcieRciMemWriteDword(U32 Address, U32 Data)
{
    int ret_val;
    int func_name = RC_MEM_WRITE_DWORD;
    
    caddr[0] = entry_point;
    caddr[1] = (char *)&lib_name;
    caddr[2] = (char *)&func_name;
    caddr[3] = (char *)&Address;
    caddr[4] = (char *)&Data;
 
    ret_val = do_go_exec((void *)addr, 5, caddr);

    return ret_val;
}

void pcieRciReadBackDoor(U32 Address, U32 *Data)
{
    int func_name = RC_READ_BACKDOOR;
    
    caddr[0] = entry_point;
    caddr[1] = (char *)&lib_name;
    caddr[2] = (char *)&func_name;
    caddr[3] = (char *)&Address;
    caddr[4] = (char *)Data;
 
    do_go_exec((void *)addr, 5, caddr);
}

void pcieRciWriteBackDoor(U32 Address, U32 Data)
{
    int func_name = RC_WRITE_BACKDOOR;
    
    caddr[0] = entry_point;
    caddr[1] = (char *)&lib_name;
    caddr[2] = (char *)&func_name;
    caddr[3] = (char *)&Address;
    caddr[4] = (char *)&Data;
 
    do_go_exec((void *)addr, 5, caddr);
}

void pcieRciGetPhyAddr(unsigned long long int *PhysAddr)
{
    int func_name = RC_GET_PHY_ADDR;
    
    caddr[0] = entry_point;
    caddr[1] = (char *)&lib_name;
    caddr[2] = (char *)&func_name;
    caddr[3] = (char *)PhysAddr;
    
    do_go_exec((void *)addr, 4, caddr);
}
 
void pcieRciGetVirtAddr(unsigned int *VirtAddr)
{
    int func_name = RC_GET_VIRT_ADDR;
    
    caddr[0] = entry_point;
    caddr[1] = (char *)&lib_name;
    caddr[2] = (char *)&func_name;
    caddr[3] = (char *)VirtAddr;

    do_go_exec((void *)addr, 4, caddr);
}

