/*******************************************************************************

NAME            lsisas3108.h
VERSION         %version: 14 %
UPDATE DATE     %date_modified: Thu Oct 17 11:30:47 2013 %
PROGRAMMER      %created_by:    weberc %

        Copyright 2013 NetApp, Inc. All rights reserved.

*******************************************************************************/
/***************************************************************************
 *                                                                         *
 *  Copyright 2010 LSI Corporation.  All rights reserved.                  *
 *                                                                         *
 ***************************************************************************
 *
 *           Name:  lsisas3108.h
 *          Title:  LSISAS3108 board configuration file
 *     Programmer:  Naresh Madhusudana
 *  Creation Date:  Aug 6, 2011
 *
 *
 * Version History
 *  ---------------
 *
 *  Date      Who   Description
 *  --------  ---   --------------------------------------------------------
 *  08/06/11  NM   Initial version.
 *
 * Description
 * ------------
 *
 *    This file consisits of LSISAS3108 board specific settings
 *
 *-------------------------------------------------------------------------
 */

#ifndef __CONFIG_H
#define __CONFIG_H

/*-----------------------------------------------------------------------
 * High Level Configuration Options
 *----------------------------------------------------------------------*/
#define CONFIG_476I                 1          /* Powerpc 476 LSISAS3108 board                            */
#define CONFIG_440                  1        /* ... PPC440 family - initialization holds good for this also */
#define CONFIG_4xx                  1        /* ... PPC4xx family */
#define CONFIG_SYS_CLK_FREQ         25000000 /* 133 Mhz external freq to pll */

#define __BIG_ENDIAN                1

#define CONFIG_HOSTNAME             LSISAS3108
#define CONFIG_USE_TTY              ttyS0
#define CONFIG_SYS_TEXT_BASE        0xFFFB0000
#define CONFIG_SYS_SDRAM_BASE       0xC0100000 /* Use OCM for system memory (Reserve 1 MB)*/
#define CONFIG_SYS_SDRAM_SIZE       0x300000   /* 3 MB for U-Boot (1 MB Reserved) */
#define CONFIG_SYS_MONITOR_BASE     0xFFFB0000 /* Start of U-Boot                                         */
#define CONFIG_SYS_MONITOR_LEN      (0xFFFFFFFF - CONFIG_SYS_MONITOR_BASE + 1)
#define CONFIG_SYS_MALLOC_LEN       (1 << 20)  /* Reserved for malloc                                     */

#define LSISAS3108_STANDALONE_ENTRY 0xFFF00000 /* This is obtained from the standalone image */

/*
 * UART
 */
#define CONFIG_BAUDRATE             115200
#define CONFIG_SYS_BAUDRATE_TABLE   {9600, 19200, 38400, 57600, 115200}

/*-----------------------------------------------------------------------
 * I2C
 *----------------------------------------------------------------------*/
#define CONFIG_HARD_I2C             1
#define CONFIG_SYS_I2C_SLAVE        0x51
#define CONFIG_SYS_I2C_SPEED        100000

/*
 * Miscellaneous configurable options
 */
#define CONFIG_BOOTDELAY            1                  /* autoboot after 1 seconds         */
#define CONFIG_MENUPROMPT           "-=<###>=-    "    /* NetApp Booting string.           */
#define CONFIG_SYS_LONGHELP                            /* undef to save memory             */
#define CONFIG_SYS_PROMPT           "U-Boot $ "        /* Monitor Command Prompt           */
#if defined(CONFIG_CMD_KGDB)
#define CONFIG_SYS_CBSIZE           1024               /* Console I/O Buffer Size          */
#else
#define CONFIG_SYS_CBSIZE           256                /* Console I/O Buffer Size          */
#endif

/* print buffer size */
#define CONFIG_SYS_PBSIZE           (CONFIG_SYS_CBSIZE+sizeof(CONFIG_SYS_PROMPT)+16)

#define CONFIG_SYS_MAXARGS          16                 /* max number of command args       */
#define CONFIG_SYS_BARGSIZE         CONFIG_SYS_CBSIZE  /* Boot Argument Buffer Size        */
/* default kernel load address - LSI=0xffdc0000 - NetApp temp: 0xff500000 */
#define CONFIG_SYS_LOAD_ADDR        0xff500000

#define CONFIG_SYS_HZ               1000             /* decrementer freq: 1 ms ticks       */

#define CONFIG_CMDLINE_EDITING                       /* add command line history           */
#define CONFIG_AUTO_COMPLETE                         /* add autocompletion support         */
#define CONFIG_LOOPW                                 /* enable loopw command               */
#define CONFIG_MX_CYCLIC                             /* enable mdc/mwc commands            */

#define CONFIG_ZERO_BOOTDELAY_CHECK                  /* check for keypress on bootdelay==0 */
#define CONFIG_VERSION_VARIABLE                      /* include version env variable       */
#undef  CONFIG_SYS_CONSOLE_INFO_QUIET                /* print console @ startup            */

#ifdef ENABLE_PRINTS
#undef CONFIG_SILENT_CONSOLE
#else
#define CONFIG_SILENT_CONSOLE
#endif

#define CONFIG_SYS_HUSH_PARSER                       /* Use the HUSH parser                */
#ifdef  CONFIG_SYS_HUSH_PARSER
#define CONFIG_SYS_PROMPT_HUSH_PS2  "> "
#endif

#define CONFIG_LOADS_ECHO                            /* echo on for serial download        */
#define CONFIG_SYS_LOADS_BAUD_CHANGE                 /* allow baudrate change              */

/*
 * For booting Linux, the board info and command line data
 * have to be in the first 16 MB of memory, since this is
 * the maximum mapped by the 40x Linux kernel during initialization.
 */
#define CONFIG_SYS_BOOTMAPSZ        (16 << 20)       /* Initial Memory map for Linux       */
#define CONFIG_SYS_BOOTM_LEN        (16 << 20)       /* Increase max gunzip size           */

/*
 * Booting and default environment
 */
#define CONFIG_BOOTCOMMAND          "cusboot 0"
#define xstr(s)                     str(s)
#define str(s)                      #s

/* Limit OS to 256MB, also done w/bootm_size env var below. The smaller of
 * the two values will take precedence. */
#define CONFIG_SYS_LINUX_LOWMEM_MAX_SIZE (256*1024*1024)

/*
 * General common environment variables
 */
#define CONFIG_DEF_ENV                                                   \
        "ramargs=setenv bootargs root=/dev/ram rw\0"                     \
        "addtty=setenv bootargs ${bootargs}"                             \
        " console=" xstr(CONFIG_USE_TTY) ",${baudrate}\0"                \
        "bootm_low=0\0"                                                  \
        "bootm_size=0x10000000\0"

#ifndef CONFIG_SILENT_CONSOLE
#define CONFIG_ENV_SILENT 0
#else
#define CONFIG_ENV_SILENT 1
#endif

/*
 * Default environment variables
 */
#define CONFIG_EXTRA_ENV_SETTINGS  \
        CONFIG_DEF_ENV             \
        "silent=" xstr(CONFIG_ENV_SILENT) "\0"   \
        ""

/*
 * Pass open firmware flat tree
 */
#define CONFIG_OF_LIBFDT            1
#undef  CONFIG_OF_BOARD_SETUP

#define CONFIG_BOARD_EARLY_INIT_F   1                /* Call board_pre_init                */
#define CONFIG_BOARD_EARLY_INIT_R   1                /* Call board_early_init_r            */

/*-----------------------------------------------------------------------
 * Base addresses -- Note these are effective addresses where the
 * actual resources get mapped (not physical addresses)
 *----------------------------------------------------------------------*/
#define CONFIG_SYS_FLASH_BASE       0xfc000000  /* start of FLASH Bank 0    */
#define CONFIG_SYS_FLASH_BASE1      0xfd000000  /* start of FLASH Bank 1    */
#define CONFIG_SYS_FLASH_BASE2      0xfe000000  /* start of FLASH Bank 2    */
#define CONFIG_SYS_FLASH_BASE3      0xff000000  /* start of FLASH Bank 3    */

#define CONFIG_SYS_PERIPHERAL_BASE  0xc2100000  /* internal peripherals     */

#define CONFIG_SYS_ISRAM_BASE       CONFIG_SYS_ISRAM_BASE1  /* Reserve Base0 for NetApp */
#define CONFIG_SYS_ISRAM_BASE0      0xc0000000  /* internal SRAM0           */
#define CONFIG_SYS_ISRAM_BASE1      0xc0100000  /* internal SRAM1           */
#define CONFIG_SYS_ISRAM_BASE2      0xc0200000  /* internal SRAM2           */
#define CONFIG_SYS_ISRAM_BASE3      0xc0300000  /* internal SRAM3           */

#define CONFIG_XMFG_MEM_BASE_ADDR   0xC2000000

/* Map DDR to 0 - the CONFIG_SYS_SDRAM_BASE now points to OCM */
#if 0
#define CONFIG_DDR3_BASE0           CONFIG_SYS_SDRAM_BASE               /* DDR3 Base 0 address is 0x0 */
#define CONFIG_DDR3_BASE1           (CONFIG_SYS_SDRAM_BASE+0x10000000)  /* DDR3 base 1                */
#define CONFIG_DDR3_BASE2           (CONFIG_SYS_SDRAM_BASE+0x20000000)  /* DDR3 base 1                */
#define CONFIG_DDR3_BASE3           (CONFIG_SYS_SDRAM_BASE+0x30000000)  /* DDR3 base 1                */
#else
#define CONFIG_DDR3_BASE0        0  /* DDR3 Base 0 address is 0x0 */
#define CONFIG_DDR3_BASE1        (CONFIG_DDR3_BASE0+0x10000000)  /* DDR3 base 1 */
#define CONFIG_DDR3_BASE2        (CONFIG_DDR3_BASE0+0x20000000)  /* DDR3 base 1 */
#define CONFIG_DDR3_BASE3        (CONFIG_DDR3_BASE0+0x30000000)  /* DDR3 base 1 */
#endif

/* uboot memory map:
 * |
 * | unused
 * |---------- 0x14000000
 * | 16MB LE uncached for drivers
 * |---------- 0x13000000
 * | 16MB BE uncached for drivers
 * |---------- 0x12000000
 * | 16MB BE cached Buffer2 for files (32MB total to match size of NOR flash)
 * |---------- 0x11000000
 * | 16MB BE cached Buffer1 for files
 * |---------- 0x10000000
 * |
 * | 256MB for OS - Starts BE cached (modified to LE later)
 * |
 * |---------- 0x00000000
 */
#define CONFIG_PHY_OS_BASE            0x400000000ULL
#define CONFIG_PHY_OS_BUF_BASE1       0x410000000ULL
#define CONFIG_PHY_OS_BUF_BASE2       0x411000000ULL
#define CONFIG_PHY_BE_DRIVER_BASE     0x412000000ULL
#define CONFIG_PHY_LE_DRIVER_BASE     0x413000000ULL

#define CONFIG_OS_BASE                0x00000000
#define CONFIG_OS_BUF_BASE1           0x10000000
#define CONFIG_OS_BUF_BASE2           0x11000000
#define CONFIG_BE_DRIVER_BASE         0x12000000
#define CONFIG_LE_DRIVER_BASE         0x13000000

/* More driver regions could be added here if necessary */
#define CONFIG_USB_MEM_BASE           (CONFIG_LE_DRIVER_BASE)
#define CONFIG_NET_MEM_BASE           (CONFIG_BE_DRIVER_BASE)

/*FPGA and NVSRAM*/
#define CONFIG_SYS_FPGA_BASE    0xf4000000
#define CONFIG_SYS_NVSRAM_BASE  0xf6000000


/* The start and end addresses for DRAM test. */
#define CONFIG_SYS_MEMTEST_START    0x0400000                           /* memtest works on           */
#define CONFIG_SYS_MEMTEST_END      0x0C00000                           /* 4 ... 12 MB in DRAM        */

/* USB experiments */
#define CONFIG_USB_EHCI
#define CONFIG_USB_EHCI_PPC4XX
#define CONFIG_SYS_PPC4XX_USB_ADDR          0x920C3B00
#define CONFIG_EHCI_HCD_INIT_AFTER_RESET
#define CONFIG_EHCI_MMIO_BIG_ENDIAN
#define CONFIG_EHCI_DESC_BIG_ENDIAN

#define CONFIG_USB_STORAGE
#define CONFIG_DOS_PARTITION
#define CONFIG_CMD_USB
#define CONFIG_CMD_FAT

#define CONFIG_PANIC_HANG

/*-----------------------------------------------------------------------
 * Initial RAM & stack pointer (placed in internal SRAM)
 *----------------------------------------------------------------------*/
#define CONFIG_SYS_TEMP_STACK_OCM   1
#define CONFIG_SYS_OCM_DATA_ADDR    CONFIG_SYS_ISRAM_BASE
#define CONFIG_SYS_INIT_RAM_ADDR    CONFIG_SYS_ISRAM_BASE               /* Initial RAM address        */
#define CONFIG_SYS_INIT_RAM_END     0x2000                              /* End of used area in RAM    */
#define CONFIG_SYS_GBL_DATA_SIZE    128                                 /* num bytes initial data     */

#define CONFIG_SYS_GBL_DATA_OFFSET  (CONFIG_SYS_INIT_RAM_END - \
                                     CONFIG_SYS_GBL_DATA_SIZE)
#define CONFIG_SYS_POST_WORD_ADDR   (CONFIG_SYS_GBL_DATA_OFFSET - 0x4)
#define CONFIG_SYS_INIT_SP_OFFSET    CONFIG_SYS_POST_WORD_ADDR

/*-----------------------------------------------------------------------
 * Serial Port
 *----------------------------------------------------------------------*/
#undef CONFIG_UART1_CONSOLE
#undef CONFIG_SYS_EXT_SERIAL_CLOCK

/*-----------------------------------------------------------------------
 * Environment
 *----------------------------------------------------------------------*/
/* Change IN_FLASH to NOWHERE to get around checking flash for uboot
   variables. Doesn't hurt anything yet, but leave this note in for
   the future. */
#define CONFIG_ENV_IS_IN_FLASH      1  /* use FLASH for environment vars                                                             */

/*-----------------------------------------------------------------------
 * FLASH related
 *----------------------------------------------------------------------*/
#define CONFIG_SYS_FLASH_CFI           /* Flash driver uses extra elements in the common flash structure for storing flash geometry. */

#define CONFIG_FLASH_CFI_DRIVER        /* enables the building of the cfi_flash driver in the drivers directory                      */

#define CONFIG_SYS_FLASH_EMPTY_INFO    /* print 'E' for empty sector on flinfo                                                       */

/* The MSB bit of PPC440 core is connected to the MSB bit of Flash chip
  * on LSISAS3108 and hence a swap of the bytes is needed between
  * reading and writing from/to Flash */

#define CONFIG_SYS_WRITE_SWAPPED_DATA

/* Flash port width is 8 Bits */
#define CONFIG_SYS_FLASH_CFI_WIDTH  (FLASH_CFI_8BIT)

#define CONFIG_SYS_FLASH_BANKS_LIST {CONFIG_SYS_FLASH_BASE}
#define CONFIG_SYS_MAX_FLASH_BANKS  1       /* number of banks                  */
#define CONFIG_SYS_MAX_FLASH_SECT   512     /* sectors per device               */

#define CONFIG_FLASH_SHOW_PROGRESS  45

#undef  CONFIG_SYS_FLASH_CHECKSUM
#define CONFIG_SYS_FLASH_ERASE_TOUT 350000  /* Timeout for Flash Erase (in ms)  */
#define CONFIG_SYS_FLASH_WRITE_TOUT 500     /* Timeout for Flash Write (in ms)  */

#define CONFIG_ENV_SECT_SIZE        0x20000 /* size of one complete sector      */
#define CONFIG_ENV_ADDR             (CONFIG_SYS_MONITOR_BASE-CONFIG_ENV_SECT_SIZE)
#define CONFIG_ENV_SIZE             0x4000  /* Total Size of Environment Sector */

#include <config_cmd_default.h>

#define CONFIG_CMD_CACHE
#define CONFIG_CMD_ELF
#define CONFIG_CMD_IRQ
/*these commands are configured by default in include/config_cmd_default.h */
#define CONFIG_CMD_PING
#define CONFIG_82574ETH
#define CONFIG_E1000
#define CONFIG_NET_MULTI
#define CONFIG_CMD_E1000
#define CONFIG_CMD_DHCP

/* Prevent autoloading files when using DHCP */
#define CONFIG_SYS_AUTOLOAD        "n"

/* DFW uses these for default values - not sure if we want to include them yet or not
#define CONFIG_IPADDR 192.168.10.125
#define CONFIG_NETMASK 255.255.255.0
#define CONFIG_SERVERIP 192.168.10.200
#define CONFIG_GATEWAYIP 192.168.10.1 
*/ 

#ifdef DEBUG
#define CONFIG_CMD_DIAG
#define CONFIG_CMD_IRQ
#endif

/*-----------------------------------------------------------------------
 * PCI Root Complex support
 *----------------------------------------------------------------------*/
#define CONFIG_PCI			1
#define CONFIG_PCI_SCAN_SHOW		1
#define CONFIG_PCI_CONFIG_HOST_BRIDGE	1
#define CONFIG_CMD_PCI		1
#define	CONFIG_SYS_EARLY_PCI_INIT	1
#endif /* __CONFIG_H */
