/***************************************************************************
 *                                                                         *
 *  Copyright (C) 2012 LSI Corporation.  All rights reserved.              *
 *                                                                         *
 *  This file is confidential and a trade secret of LSI Corporation. The   *
 *  receipt of or possession of this file does not convey any rights to    *
 *  reproduce or disclose its contents or to manufacture, use, or sell     *
 *  anything it may describe, in whole, or in part, without the specific   *
 *  written consent of LSI Corporation.                                    *
 *                                                                         *
 ***************************************************************************
 *
 *           Name:  gpioDebug.h
 *          Title:  GPIO Debug macros and defintions
 *     Programmer:  Naresh Bhalala
 *  Creation Date:  09 June 2012
 *
 *
 * Description
 * ------------
 * This include file contains GPIO debug macros and defines.
 *
 *-------------------------------------------------------------------------
 */

#ifndef GPIO_DEBUG_HEADER
#define GPIO_DEBUG_HEADER

/* GPIO PRINT Constants
 * WARNING: this section is auto-generated.  Changes here will be overwritten
 * Make changes in gpioDebugTmpl.h or gpioDebugStrings.h
 */

#define GPIO_DBG_STR_MAX_INDEX		23

/* AUTOGEN_INDICES_START - NOTE: this token is needed for the build process */
#define GPIO_DBG_STR_HAL_DRIVER_USAGE			32769
#define GPIO_DBG_STR_HAL_DRIVER_INVALID_MAJOR_NO			32770
#define GPIO_DBG_STR_INT_DRIVER_INIT_ALLOC_CHRDEV_REGION			32771
#define GPIO_DBG_STR_INT_DRIVER_INIT_CDEV_ADD			32772
#define GPIO_DBG_STR_INT_DRIVER_INIT_INFO			32773
#define GPIO_DBG_STR_INT_DRIVER_INIT			32774
#define GPIO_DBG_STR_INT_DRIVER_SET_HEARTBEAT			32775
#define GPIO_DBG_STR_INT_DRIVER_WRITE_INFO			32776
#define GPIO_DBG_STR_INT_DRIVER_WRITE_BYTE			32777
#define GPIO_DBG_STR_INT_DRIVER_WRITE_CURR_VAL			32778
#define GPIO_DBG_STR_INT_DRIVER_WRITE_MODES			32779
#define GPIO_DBG_STR_INT_DRIVER_OPEN_NUM			32780
#define GPIO_DBG_STR_INT_DRIVER_CLOSE_NUM			32781
#define GPIO_DBG_STR_INTERRUPT_HANDLER_EXT0			32782
#define GPIO_DBG_STR_INTERRUPT_HANDLER_EXT1			32783
#define GPIO_DBG_STR_INTERRUPT_HANDLER_EXT2			32784
#define GPIO_DBG_STR_INTERRUPT_HANDLER_EXT3			32785
#define GPIO_DBG_STR_INTERRUPT_HANDLER_EXT4			32786
#define GPIO_DBG_STR_INTERRUPT_HANDLER_EXT5			32787
#define GPIO_DBG_STR_INTERRUPT_HANDLER_EXT6			32788
#define GPIO_DBG_STR_INTERRUPT_HANDLER_EXT7			32789
#define GPIO_DBG_STR_INTERRUPT_INIT_HANDLER_NOT_SET			32790
#define GPIO_DBG_STR_INTERRUPT_VIRTUAL_IRQ_NOT_RXD			32791
/* AUTOGEN_INDICES_END   - NOTE: this token is needed for the build process */
/* WARNING: the above defines are auto-generated from gpioDebugStrings.h */


/* WARNING: this section is auto-generated.  Changes here will be overwritten */
/* DIAG_PARSE_START_STRING_PARAM_SECTION Note: This token marks the start of the string parameter section for the parser*/
#define GPIO_DBG_PREFIX_FORMAT_STR_PARAMS_0 0 	/*P-000*/
#define GPIO_DBG_PREFIX_FORMAT_STR_PARAMS_1 0 	/*P-001*/
#define GPIO_DBG_PREFIX_FORMAT_STR_PARAMS_2 0 	/*P-002*/
#define GPIO_DBG_PREFIX_FORMAT_STR_PARAMS_3 1 	/*P-003*/
#define GPIO_DBG_PREFIX_FORMAT_STR_PARAMS_4 1 	/*P-004*/
#define GPIO_DBG_PREFIX_FORMAT_STR_PARAMS_5 2 	/*P-005*/
#define GPIO_DBG_PREFIX_FORMAT_STR_PARAMS_6 1 	/*P-006*/
#define GPIO_DBG_PREFIX_FORMAT_STR_PARAMS_7 1 	/*P-007*/
#define GPIO_DBG_PREFIX_FORMAT_STR_PARAMS_8 1 	/*P-008*/
#define GPIO_DBG_PREFIX_FORMAT_STR_PARAMS_9 1 	/*P-009*/
#define GPIO_DBG_PREFIX_FORMAT_STR_PARAMS_10 1 	/*P-010*/
#define GPIO_DBG_PREFIX_FORMAT_STR_PARAMS_11 2 	/*P-011*/
#define GPIO_DBG_PREFIX_FORMAT_STR_PARAMS_12 1 	/*P-012*/
#define GPIO_DBG_PREFIX_FORMAT_STR_PARAMS_13 1 	/*P-013*/
#define GPIO_DBG_PREFIX_FORMAT_STR_PARAMS_14 0 	/*P-014*/
#define GPIO_DBG_PREFIX_FORMAT_STR_PARAMS_15 0 	/*P-015*/
#define GPIO_DBG_PREFIX_FORMAT_STR_PARAMS_16 0 	/*P-016*/
#define GPIO_DBG_PREFIX_FORMAT_STR_PARAMS_17 0 	/*P-017*/
#define GPIO_DBG_PREFIX_FORMAT_STR_PARAMS_18 0 	/*P-018*/
#define GPIO_DBG_PREFIX_FORMAT_STR_PARAMS_19 0 	/*P-019*/
#define GPIO_DBG_PREFIX_FORMAT_STR_PARAMS_20 0 	/*P-020*/
#define GPIO_DBG_PREFIX_FORMAT_STR_PARAMS_21 0 	/*P-021*/
#define GPIO_DBG_PREFIX_FORMAT_STR_PARAMS_22 2 	/*P-022*/
#define GPIO_DBG_PREFIX_FORMAT_STR_PARAMS_23 0 	/*P-023*/
/* DIAG_PARSE_END_STRING_PARAM_SECTION   Note: This token marks the end of the string parameter section for the parser*/

#endif /* end of file */
