/***************************************************************************
 *                                                                         *
 *  Copyright (C) 2012 LSI Corporation.  All rights reserved.              *
 *                                                                         *
 *  This file is confidential and a trade secret of LSI Corporation. The   *
 *  receipt of or possession of this file does not convey any rights to    *
 *  reproduce or disclose its contents or to manufacture, use, or sell     *
 *  anything it may describe, in whole, or in part, without the specific   *
 *  written consent of LSI Corporation.                                    *
 *                                                                         *
 ***************************************************************************
 *
 *           Name:  iocDebug.h
 *          Title:  IOC Debug macros and defintions
 *     Programmer:  Naresh Bhalala
 *  Creation Date:  12 June 2012
 *
 *
 * Description
 * ------------
 * This include file contains IOC debug macros and defines.
 *
 *-------------------------------------------------------------------------
 */

#ifndef IOC_DEBUG_HEADER
#define IOC_DEBUG_HEADER

/* IOC PRINT Constants
 * WARNING: this section is auto-generated.  Changes here will be overwritten
 * Make changes in iocDebugTmpl.h or iocDebugStrings.h
 */

#define IOC_DBG_STR_MAX_INDEX		84

/* AUTOGEN_INDICES_START - NOTE: this token is needed for the build process */
#define IOC_DBG_STR_NEWLINE			40961
#define IOC_DBG_STR_EXITED			40962
#define IOC_DBG_STR_SUCCESSFULLY_COMPLETED			40963
#define IOC_DBG_STR_HAL_DRIVER_USAGE			40964
#define IOC_DBG_STR_HAL_DRIVER_INVALID_MAJOR_NO			40965
#define IOC_DBG_STR_INT_DRIVER_ADAPTER_RST_WRITE_CLRD			40966
#define IOC_DBG_STR_INT_DRIVER_INIT_INVALID_MAJOR_NO			40967
#define IOC_DBG_STR_INT_DRIVER_INIT_IOP_PL_INIT_FAIL			40968
#define IOC_DBG_STR_INT_DRIVER_INIT_GET_RT_CONFIG_FAIL			40969
#define IOC_DBG_STR_INT_DRIVER_INIT_TIMER_CREAT_FOR_THRD_FAIL			40970
#define IOC_DBG_STR_INT_DRIVER_INIT_IOC_NOT_READY			40971
#define IOC_DBG_STR_INT_DRIVER_OPEN_GET_MODULE_ERR			40972
#define IOC_DBG_STR_INT_DRIVER_EXIT_ENTER_UNLOAD_IOC_DRIVER			40973
#define IOC_DBG_STR_INT_DRIVER_EXIT_IOC_DRIVER_UNLOADED			40974
#define IOC_DBG_STR_DOORBELL_SET_REPLY_FREE_HOST_INDEX_FAIL			40975
#define IOC_DBG_STR_DOORBELL_SET_REPLY_POST_LST_PROD_INDX_FAIL			40976
#define IOC_DBG_STR_DOORBELL_SET_RPLY_POST_HOST_INDEX_FAIL			40977
#define IOC_DBG_STR_DOORBELL_WRITE_DB			40978
#define IOC_DBG_STR_DOORBELL_HANDLER_GET_VAL_FAIL			40979
#define IOC_DBG_STR_DOORBELL_HANDLER_READ			40980
#define IOC_DBG_STR_DOORBELL_HANDLER_IOP_FAULT			40981
#define IOC_DBG_STR_DOORBELL_HANDLER_RST_FAIL			40982
#define IOC_DBG_STR_DOORBELL_HANDLER_PRE_PRO_REQ_FAIL			40983
#define IOC_DBG_STR_DOORBELL_HANDLER_INVALID_FUNCTION			40984
#define IOC_DBG_STR_DOORBELL_HANDLER_INVALID_PROCESS_STATE			40985
#define IOC_DBG_STR_DOORBELL_PRE_PROCESS_REQ_GET_FRM_FAIL			40986
#define IOC_DBG_STR_DOORBELL_PRE_PROCESS_REQ_FRAME_ALLOC_FAIL			40987
#define IOC_DBG_STR_DOORBELL_PRE_PROCESS_REQ_MEM_ALLOC_MSG_QUE_FAIL			40988
#define IOC_DBG_STR_DOORBELL_IOC_FACTS_KMALLOC_IOUNITPAGE1_FAIL			40989
#define IOC_DBG_STR_DOORBELL_IOC_FACTS_READ_CONFIG_PAGE1_FAIL			40990
#define IOC_DBG_STR_DOORBELL_IOC_FACTS_KMALLOC_SAS_IOUNITPAGE1_FAIL			40991
#define IOC_DBG_STR_DOORBELL_IOC_FACTS_READ_SAS_IOUNIT_PAGE_FAIL			40992
#define IOC_DBG_STR_DOORBELL_IOC_FACTS_KMALLOC_IOCPAGE8_FAIL			40993
#define IOC_DBG_STR_DOORBELL_IOC_FACTS_READ_IOC_PAGE8_FAIL			40994
#define IOC_DBG_STR_DOORBELL_IOC_FACTS_SND_REPLY_IOC_FAIL			40995
#define IOC_DBG_STR_DOORBELL_PORT_FACTS_SND_REPLY_PORT_FAIL			40996
#define IOC_DBG_STR_DOORBELL_INIT_IOC_TRANSPORT_MF_INIT_FAIL			40997
#define IOC_DBG_STR_DOORBELL_INIT_SYSTM_MSG_POOL_ADDR_INIT_FAIL			40998
#define IOC_DBG_STR_DOORBELL_INIT_LOCAL_QUE_INIT_FAIL			40999
#define IOC_DBG_STR_DOORBELL_INIT_GET_MSG_PULL_CNTRL_STATUS_FAIL			41000
#define IOC_DBG_STR_DOORBELL_INIT_SET_MSG_PULL_CNTRL_STATUS_FAIL			41001
#define IOC_DBG_STR_DOORBELL_INIT_ENABLE_LOCAL_QUE_FAIL			41002
#define IOC_DBG_STR_DOORBELL_INIT_SET_PARAMS_FAIL			41003
#define IOC_DBG_STR_DOORBELL_INIT_DB_STATE_INFO			41004
#define IOC_DBG_STR_DOORBELL_INIT_REPLY_MSG_HANDLER_FAIL			41005
#define IOC_DBG_STR_DOORBELL_RST_WRITE_TO_DB_REG_FAIL			41006
#define IOC_DBG_STR_DOORBELL_RST_FREE_FRAME_FAIL			41007
#define IOC_DBG_STR_DOORBELL_SERVICE_FUNCTION_UNSUPPORT			41008
#define IOC_DBG_STR_DOORBELL_DB_WRITE_FREE_FRAME_FAIL_STATUS			41009
#define IOC_DBG_STR_DOORBELL_DB_WRITE_MSG_SND_To_HOST_DONE			41010
#define IOC_DBG_STR_EVENT_DETECTED_DONT_SEND_TO_HOST			41011
#define IOC_DBG_STR_EVENT_DETECTED_UNKNOWN_EVENT			41012
#define IOC_DBG_STR_EVENT_DETECTED_MASKED			41013
#define IOC_DBG_STR_INTERRUPT_DUMP_MPIC_CONFIG_REGS_INFO			41014
#define IOC_DBG_STR_INTERRUPT_DUMP_MPIC_PROCESSOR_PRIORITY_SET_INFO			41015
#define IOC_DBG_STR_INTERRUPT_DUMP_MPIC_VECTOR_PRIORITY_REGS			41016
#define IOC_DBG_STR_INTERRUPT_DUMP_MPIC_IRQ_INFO			41017
#define IOC_DBG_STR_INTERRUPT_DUMP_MPIC_CURRENT_NON_CRIT_GET_VECTOR			41018
#define IOC_DBG_STR_INTERRUPT_HANDLER_DB_HANDLER_FAIL			41019
#define IOC_DBG_STR_INTERRUPT_INIT_NOT_SET_STATUS			41020
#define IOC_DBG_STR_INTERRUPT_INIT_NOT_REGD_WITH_KRNL_INFO			41021
#define IOC_DBG_STR_INTERRUPT_UNREG_ERR			41022
#define IOC_DBG_STR_SCHEDULER_REQ_MSG_RAW_FRAME_MSG_DWORDS			41023
#define IOC_DBG_STR_SCHEDULER_REQ_MSG_REQESTED_FUCTN			41024
#define IOC_DBG_STR_SCHEDULER_RPLY_MSG_SND_TO_HOST			41025
#define IOC_DBG_STR_SCHEDULER_CFG_REQ_MEM_MOV_FAIL			41026
#define IOC_DBG_STR_SCHEDULER_CFG_REQ_FAIL_STATUS			41027
#define IOC_DBG_STR_SCHEDULER_CFG_REQ_SUCCESS			41028
#define IOC_DBG_STR_SCHEDULER_CFG_REQ_MEM_MOV_SUCCESS			41029
#define IOC_DBG_STR_TRANSPORT_FRAME_ALLOC_FAIL			41030
#define IOC_DBG_STR_TRANSPORT_MF_INIT_REQ_MSG_QUE_FAIL			41031
#define IOC_DBG_STR_TRANSPORT_MF_INIT_RPLY_MSG_QUE_FAIL			41032
#define IOC_DBG_STR_TRANSPORT_MF_INIT_REQ_POST_QUE_INIT_FAIL			41033
#define IOC_DBG_STR_TRANSPORT_MF_INIT_HIGH_QUE_INIT_FAIL			41034
#define IOC_DBG_STR_TRANSPORT_MF_INIT_GENRIC_HS_FIFO_INIT_FAIL			41035
#define IOC_DBG_STR_TRANSPORT_MF_INIT_MSG_UNIT_ERR_FAIL			41036
#define IOC_DBG_STR_TRANSPORT_MF_INIT_DESC_SOFT_FIFO_FAIL			41037
#define IOC_DBG_STR_TRANSPORT_MF_ALLOC_16_MEM_ALLOC_FAIL			41038
#define IOC_DBG_STR_TRANSPORT_MF_HANDLER_FIFO_ADDR_INFO			41039
#define IOC_DBG_STR_TRANSPORT_MF_HANDLER_REQ_DSC_POST_QUEUE_EMPTY			41040
#define IOC_DBG_STR_TRANSPORT_MF_HANDLER_REQ_DESC_POST_QUE_EMPTY			41041
#define IOC_DBG_STR_TRANSPORT_MF_LOCAL_MSG_UNKNOWN_REQ_DESC_RXD			41042
#define IOC_DBG_STR_TRANSPORT_DATA_TRANSFER_DMA_FAIL			41043
#define IOC_DBG_STR_TRANSPORT_REPLY_HANDLER_WRITE_DB_DATA_FAIL			41044
/* AUTOGEN_INDICES_END   - NOTE: this token is needed for the build process */
/* WARNING: the above defines are auto-generated from iocDebugStrings.h */


/* WARNING: this section is auto-generated.  Changes here will be overwritten */
/* DIAG_PARSE_START_STRING_PARAM_SECTION Note: This token marks the start of the string parameter section for the parser*/
#define IOC_DBG_PREFIX_FORMAT_STR_PARAMS_0 0 	/*P-000*/
#define IOC_DBG_PREFIX_FORMAT_STR_PARAMS_1 0 	/*P-001*/
#define IOC_DBG_PREFIX_FORMAT_STR_PARAMS_2 0 	/*P-002*/
#define IOC_DBG_PREFIX_FORMAT_STR_PARAMS_3 0 	/*P-003*/
#define IOC_DBG_PREFIX_FORMAT_STR_PARAMS_4 0 	/*P-004*/
#define IOC_DBG_PREFIX_FORMAT_STR_PARAMS_5 0 	/*P-005*/
#define IOC_DBG_PREFIX_FORMAT_STR_PARAMS_6 0 	/*P-006*/
#define IOC_DBG_PREFIX_FORMAT_STR_PARAMS_7 0 	/*P-007*/
#define IOC_DBG_PREFIX_FORMAT_STR_PARAMS_8 0 	/*P-008*/
#define IOC_DBG_PREFIX_FORMAT_STR_PARAMS_9 0 	/*P-009*/
#define IOC_DBG_PREFIX_FORMAT_STR_PARAMS_10 0 	/*P-010*/
#define IOC_DBG_PREFIX_FORMAT_STR_PARAMS_11 0 	/*P-011*/
#define IOC_DBG_PREFIX_FORMAT_STR_PARAMS_12 1 	/*P-012*/
#define IOC_DBG_PREFIX_FORMAT_STR_PARAMS_13 0 	/*P-013*/
#define IOC_DBG_PREFIX_FORMAT_STR_PARAMS_14 0 	/*P-014*/
#define IOC_DBG_PREFIX_FORMAT_STR_PARAMS_15 0 	/*P-015*/
#define IOC_DBG_PREFIX_FORMAT_STR_PARAMS_16 0 	/*P-016*/
#define IOC_DBG_PREFIX_FORMAT_STR_PARAMS_17 0 	/*P-017*/
#define IOC_DBG_PREFIX_FORMAT_STR_PARAMS_18 1 	/*P-018*/
#define IOC_DBG_PREFIX_FORMAT_STR_PARAMS_19 0 	/*P-019*/
#define IOC_DBG_PREFIX_FORMAT_STR_PARAMS_20 1 	/*P-020*/
#define IOC_DBG_PREFIX_FORMAT_STR_PARAMS_21 0 	/*P-021*/
#define IOC_DBG_PREFIX_FORMAT_STR_PARAMS_22 0 	/*P-022*/
#define IOC_DBG_PREFIX_FORMAT_STR_PARAMS_23 0 	/*P-023*/
#define IOC_DBG_PREFIX_FORMAT_STR_PARAMS_24 0 	/*P-024*/
#define IOC_DBG_PREFIX_FORMAT_STR_PARAMS_25 0 	/*P-025*/
#define IOC_DBG_PREFIX_FORMAT_STR_PARAMS_26 0 	/*P-026*/
#define IOC_DBG_PREFIX_FORMAT_STR_PARAMS_27 0 	/*P-027*/
#define IOC_DBG_PREFIX_FORMAT_STR_PARAMS_28 0 	/*P-028*/
#define IOC_DBG_PREFIX_FORMAT_STR_PARAMS_29 0 	/*P-029*/
#define IOC_DBG_PREFIX_FORMAT_STR_PARAMS_30 0 	/*P-030*/
#define IOC_DBG_PREFIX_FORMAT_STR_PARAMS_31 0 	/*P-031*/
#define IOC_DBG_PREFIX_FORMAT_STR_PARAMS_32 0 	/*P-032*/
#define IOC_DBG_PREFIX_FORMAT_STR_PARAMS_33 0 	/*P-033*/
#define IOC_DBG_PREFIX_FORMAT_STR_PARAMS_34 0 	/*P-034*/
#define IOC_DBG_PREFIX_FORMAT_STR_PARAMS_35 0 	/*P-035*/
#define IOC_DBG_PREFIX_FORMAT_STR_PARAMS_36 0 	/*P-036*/
#define IOC_DBG_PREFIX_FORMAT_STR_PARAMS_37 0 	/*P-037*/
#define IOC_DBG_PREFIX_FORMAT_STR_PARAMS_38 0 	/*P-038*/
#define IOC_DBG_PREFIX_FORMAT_STR_PARAMS_39 0 	/*P-039*/
#define IOC_DBG_PREFIX_FORMAT_STR_PARAMS_40 0 	/*P-040*/
#define IOC_DBG_PREFIX_FORMAT_STR_PARAMS_41 0 	/*P-041*/
#define IOC_DBG_PREFIX_FORMAT_STR_PARAMS_42 0 	/*P-042*/
#define IOC_DBG_PREFIX_FORMAT_STR_PARAMS_43 1 	/*P-043*/
#define IOC_DBG_PREFIX_FORMAT_STR_PARAMS_44 1 	/*P-044*/
#define IOC_DBG_PREFIX_FORMAT_STR_PARAMS_45 0 	/*P-045*/
#define IOC_DBG_PREFIX_FORMAT_STR_PARAMS_46 0 	/*P-046*/
#define IOC_DBG_PREFIX_FORMAT_STR_PARAMS_47 0 	/*P-047*/
#define IOC_DBG_PREFIX_FORMAT_STR_PARAMS_48 0 	/*P-048*/
#define IOC_DBG_PREFIX_FORMAT_STR_PARAMS_49 1 	/*P-049*/
#define IOC_DBG_PREFIX_FORMAT_STR_PARAMS_50 0 	/*P-050*/
#define IOC_DBG_PREFIX_FORMAT_STR_PARAMS_51 0 	/*P-051*/
#define IOC_DBG_PREFIX_FORMAT_STR_PARAMS_52 0 	/*P-052*/
#define IOC_DBG_PREFIX_FORMAT_STR_PARAMS_53 0 	/*P-053*/
#define IOC_DBG_PREFIX_FORMAT_STR_PARAMS_54 4 	/*P-054*/
#define IOC_DBG_PREFIX_FORMAT_STR_PARAMS_55 4 	/*P-055*/
#define IOC_DBG_PREFIX_FORMAT_STR_PARAMS_56 0 	/*P-056*/
#define IOC_DBG_PREFIX_FORMAT_STR_PARAMS_57 3 	/*P-057*/
#define IOC_DBG_PREFIX_FORMAT_STR_PARAMS_58 1 	/*P-058*/
#define IOC_DBG_PREFIX_FORMAT_STR_PARAMS_59 0 	/*P-059*/
#define IOC_DBG_PREFIX_FORMAT_STR_PARAMS_60 2 	/*P-060*/
#define IOC_DBG_PREFIX_FORMAT_STR_PARAMS_61 1 	/*P-061*/
#define IOC_DBG_PREFIX_FORMAT_STR_PARAMS_62 1 	/*P-062*/
#define IOC_DBG_PREFIX_FORMAT_STR_PARAMS_63 3 	/*P-063*/
#define IOC_DBG_PREFIX_FORMAT_STR_PARAMS_64 1 	/*P-064*/
#define IOC_DBG_PREFIX_FORMAT_STR_PARAMS_65 0 	/*P-065*/
#define IOC_DBG_PREFIX_FORMAT_STR_PARAMS_66 0 	/*P-066*/
#define IOC_DBG_PREFIX_FORMAT_STR_PARAMS_67 1 	/*P-067*/
#define IOC_DBG_PREFIX_FORMAT_STR_PARAMS_68 0 	/*P-068*/
#define IOC_DBG_PREFIX_FORMAT_STR_PARAMS_69 0 	/*P-069*/
#define IOC_DBG_PREFIX_FORMAT_STR_PARAMS_70 0 	/*P-070*/
#define IOC_DBG_PREFIX_FORMAT_STR_PARAMS_71 0 	/*P-071*/
#define IOC_DBG_PREFIX_FORMAT_STR_PARAMS_72 0 	/*P-072*/
#define IOC_DBG_PREFIX_FORMAT_STR_PARAMS_73 0 	/*P-073*/
#define IOC_DBG_PREFIX_FORMAT_STR_PARAMS_74 0 	/*P-074*/
#define IOC_DBG_PREFIX_FORMAT_STR_PARAMS_75 0 	/*P-075*/
#define IOC_DBG_PREFIX_FORMAT_STR_PARAMS_76 0 	/*P-076*/
#define IOC_DBG_PREFIX_FORMAT_STR_PARAMS_77 0 	/*P-077*/
#define IOC_DBG_PREFIX_FORMAT_STR_PARAMS_78 0 	/*P-078*/
#define IOC_DBG_PREFIX_FORMAT_STR_PARAMS_79 1 	/*P-079*/
#define IOC_DBG_PREFIX_FORMAT_STR_PARAMS_80 0 	/*P-080*/
#define IOC_DBG_PREFIX_FORMAT_STR_PARAMS_81 0 	/*P-081*/
#define IOC_DBG_PREFIX_FORMAT_STR_PARAMS_82 0 	/*P-082*/
#define IOC_DBG_PREFIX_FORMAT_STR_PARAMS_83 0 	/*P-083*/
#define IOC_DBG_PREFIX_FORMAT_STR_PARAMS_84 0 	/*P-084*/
/* DIAG_PARSE_END_STRING_PARAM_SECTION   Note: This token marks the end of the string parameter section for the parser*/

#endif /* end of file */
