/***************************************************************************
 *                                                                         *
 *  Copyright (C) 2012 LSI Corporation.  All rights reserved.              *
 *                                                                         *
 *  This file is confidential and a trade secret of LSI Corporation. The   *
 *  receipt of or possession of this file does not convey any rights to    *
 *  reproduce or disclose its contents or to manufacture, use, or sell     *
 *  anything it may describe, in whole, or in part, without the specific   *
 *  written consent of LSI Corporation.                                    *
 *                                                                         *
 ***************************************************************************
 *
 *           Name:  osalKernel.h
 *          Title:  OS wrappers Header File
 *     Programmer:  Naresh Bhalala
 *  Creation Date:  April 27, 2012
 *
 *  Version History
 *  ---------------
 *
 *  Date      Who   Description
 *  --------  ---   -------------------------------------------------------
 *  04/27/12  NB    Initial version.
 *  04/30/12  NB    Made common for peripherals - Flash, I2C, Ethernet, GPIO, UART
 *
 *  Description
 *  ------------
 *  This file contains the definitions and the function prototypes of the
 *  functions called in the osalKernel.c
 *
 *-------------------------------------------------------------------------
 */

#ifndef _OSAL_KERNEL_H_SOURCE
#define _OSAL_KERNEL_H_SOURCE

#include "basetype.h"

void osalPrintk                         ( const char* format, ... );
void * osalIoremap                      ( unsigned long long Address, U32 SizeBytes );
void osalIounmap                        ( void * Address );
void osalUdelay                         ( U32 Delay );
void osalMdelay                         ( Ul32 Delay );
void osalMemset                         ( void * Address, U8 Value, U32 Count );
void * osalConvertPhysicalToVirtual     ( unsigned long long Address );
U32  osalMoveFromDcr                    ( S32 RegAddress );
void osalMoveToDcr                      ( U32 RegAddress, U32 Value );

#endif /* _OSAL_KERNEL_H_SOURCE */
