/***************************************************************************
 *                                                                         *
 *  Copyright (C) 2012 LSI Corporation.  All rights reserved.              *
 *                                                                         *
 *  This file is confidential and a trade secret of LSI Corporation. The   *
 *  receipt of or possession of this file does not convey any rights to    *
 *  reproduce or disclose its contents or to manufacture, use, or sell     *
 *  anything it may describe, in whole, or in part, without the specific   *
 *  written consent of LSI Corporation.                                    *
 *                                                                         *
 ***************************************************************************
 *
 *           Name:  flashEngineDrv.h
 *          Title:  FLASH Engine Driver header file
 *     Programmer:  Naresh Bhalala
 *  Creation Date:  April 20, 2012
 *
 *  Version History
 *  ---------------
 *
 *  Date      Who   Description
 *  --------  ---   --------------------------------------------------------
 *  04/20/12  NB    Initial version.
 *
 * Description
 * ------------
 * This file contains the definitions for the FLASH Engine Driver.
 *
 * -------------------------------------------------------------------------
 */

#ifndef FLASH_ENGINE_DRV_H
#define FLASH_ENGINE_DRV_H

#include <linux/module.h>

#include "basetype.h"         /* Basic Types                   */
#include "commonInterface.h"  /* Common Interface Header File. */

/* ---------------------------------------------------------------------- */
/* Macros                                                                 */
/* ---------------------------------------------------------------------- */
/* Component engine driver interfaces */
typedef struct _COMPONENT_ENGINE_DRIVER
{
    void *(*osalIoremap)       ( unsigned long long, U32 );
    void (*osalIounmap)        ( void* );
    void (*osalMdelay)         ( unsigned long );
    void (*iopiTracePrint0)    (long long Pattern, U32 Index);
    void (*iopiTracePrint1)    (long long Pattern, U32 Index, U32 Arg1);
    void (*iopiTracePrint2)    (long long Pattern, U32 Index, U32 Arg1, U32 Arg2);
    void (*iopiTracePrint3)    (long long Pattern, U32 Index, U32 Arg1, U32 Arg2, U32 Arg3);
    void (*iopiTracePrint4)    (long long Pattern, U32 Index, U32 Arg1, U32 Arg2, U32 Arg3, U32 Arg4);
    void (*iopiConsolePrint0)  ( char * FmtStr);
    void (*iopiConsolePrint1)  ( char * FmtStr, U32 Arg1);
    void (*iopiConsolePrint2)  ( char * FmtStr, U32 Arg1, U32 Arg2);
    void (*iopiConsolePrint3)  ( char * FmtStr, U32 Arg1, U32 Arg2, U32 Arg3);
    void (*iopiConsolePrint4)  ( char * FmtStr, U32 Arg1, U32 Arg2, U32 Arg3, U32 Arg4);

} COMPONENT_ENGINE_DRIVER, *PTR_COMPONENT_ENGINE_DRIVER;
extern COMPONENT_ENGINE_DRIVER gComponentEngineDriver;

/* ---------------------------------------------------------------------- */
/* Externs                                                                */
/* ---------------------------------------------------------------------- */

extern int flashHalRegisterInterfaceDriver   ( ENGINE_DRIVER IfaceData );
extern int flashHalUnregisterInterfaceDriver ( U32 MajorNumber );

#endif /* FLASH_ENGINE_DRV_H */
