/***************************************************************************
 *                                                                         *
 *  Copyright (C) 2012 LSI Corporation.  All rights reserved.              *
 *                                                                         *
 *  This file is confidential and a trade secret of LSI Corporation. The   *
 *  receipt of or possession of this file does not convey any rights to    *
 *  reproduce or disclose its contents or to manufacture, use, or sell     *
 *  anything it may describe, in whole, or in part, without the specific   *
 *  written consent of LSI Corporation.                                    *
 *                                                                         *
 ***************************************************************************
 *
 *           Name:  uartEngineDrv.h
 *          Title:  UART Engine Driver header file
 *     Programmer:  Jignesh Moradiya
 *  Creation Date:  April 06, 2012
 *
 *  Version History
 *  ---------------
 *
 *  Date      Who   Description
 *  --------  ---   --------------------------------------------------------
 *  04/06/12  NB    Initial version.
 *  
 *  Description
 *  ------------
 *  This file contains the definitions for the UART Engine Driver.
 *
 * -------------------------------------------------------------------------
 */
#ifndef UART_ENGINE_DRV_H
#define UART_ENGINE_DRV_H

#include <linux/module.h>

#include "basetype.h"
#include "commonInterface.h"

/* ------------------------------------------------------------------------ */
/* Macros                                                                   */
/* ------------------------------------------------------------------------ */

/* Component engine driver interfaces */
typedef struct _COMPONENT_ENGINE_DRIVER
{
    void *(*osalIoremap)                  (unsigned long long, U32);
    void (*osalIounmap)                   (void*);
    void *(*osalConvertPhysicalToVirtual) (unsigned long long);
    void (*osalUdelay)                    (U32);
    void (*iopiTracePrint0)               (long long Pattern, U32 Index);
    void (*iopiTracePrint1)               (long long Pattern, U32 Index, U32 Arg1);
    void (*iopiTracePrint2)               (long long Pattern, U32 Index, U32 Arg1, U32 Arg2);
    void (*iopiTracePrint3)               (long long Pattern, U32 Index, U32 Arg1, U32 Arg2, U32 Arg3);
    void (*iopiTracePrint4)               (long long Pattern, U32 Index, U32 Arg1, U32 Arg2, U32 Arg3, U32 Arg4);
    void (*iopiConsolePrint0)             ( char * FmtStr);
    void (*iopiConsolePrint1)             ( char * FmtStr, U32 Arg1);
    void (*iopiConsolePrint2)             ( char * FmtStr, U32 Arg1, U32 Arg2);
    void (*iopiConsolePrint3)             ( char * FmtStr, U32 Arg1, U32 Arg2, U32 Arg3);
    void (*iopiConsolePrint4)             ( char * FmtStr, U32 Arg1, U32 Arg2, U32 Arg3, U32 Arg4);

} COMPONENT_ENGINE_DRIVER, *PTR_COMPONENT_ENGINE_DRIVER;
extern COMPONENT_ENGINE_DRIVER gComponentEngineDriver;

/* ------------------------------------------------------------------------ */
/* Externs - Registration functions                                         */
/* ------------------------------------------------------------------------ */

extern int uartHalRegisterInterfaceDriver   ( ENGINE_DRIVER IfaceData );
extern int uartHalUnregisterInterfaceDriver ( U32 MajorNumber );

#endif /* UART_ENGINE_DRV_H */
