/***************************************************************************
 *                                                                         *
 *  Copyright 2010-2011 LSI Corporation.  All rights reserved.             *
 *                                                                         *
 *  This file is confidential and a trade secret of LSI Corp.  The         *
 *  receipt of or possession of this file does not convey any rights to    *
 *  reproduce or disclose its contents or to manufacture, use, or sell     *
 *  anything it may describe, in whole, or in part, without the specific   *
 *  written consent of LSI Corporation.                                    *
 *                                                                         *
 ***************************************************************************
 *
 *           Name:  ddriProtos.h
 *          Title:  IOP to DDR Interface functions
 *     Programmer:  craigc
 *  Creation Date:  17sept09
 *
 *
 * Description
 * ------------
 */


#ifndef DDRIPROTOS_H_INCLUDED
#define DDRIPROTOS_H_INCLUDED



/*
 *
 */
const char* ddriGetLibraryRevision(void);
const char* ddriGetLibraryBuildDate(void);
const char* ddriGetLibraryBuildTime(void);
void ddriSpdGetCompanyName(PTR_DDRI_DDR3_SPD_DATA pSpd, char *pNameString);
void ddriSpdGetPartNumber(PTR_DDRI_DDR3_SPD_DATA pSpd, char *pNameString);
void ddriSpdGetSerialNumber(PTR_DDRI_DDR3_SPD_DATA pSpd, char *pNameString);
void ddriSpdGetDimmType(PTR_DDRI_DDR3_SPD_DATA pSpd, char *pNameString);
void ddriSpdGetUdimmRawCard(PTR_DDRI_DDR3_SPD_DATA pSpd, char *pNameString);
U32 ddriSpdGetUdimmRawCardRev(PTR_DDRI_DDR3_SPD_DATA pSpd);
BOOL ddriSpdIsUdimmAddressMirrored(PTR_DDRI_DDR3_SPD_DATA pSpd);
BOOL ddriSpdIsDimmRegistered(PTR_DDRI_DDR3_SPD_DATA pSpd);
U32 ddriSpdGetNumbRanks(PTR_DDRI_DDR3_SPD_DATA pSpd);
U32 ddriSpdGetSdramDevWidth(PTR_DDRI_DDR3_SPD_DATA pSpd);
U32 ddriSpdGetSdramCapacity(PTR_DDRI_DDR3_SPD_DATA pSpd);
U32 ddriSpdGetBusWidth(PTR_DDRI_DDR3_SPD_DATA pSpd);
U32 ddriSpdGetMaxFreq(PTR_DDRI_DDR3_SPD_DATA pSpd);
U32 ddriSpdComputeDimmSizeMb(U32 sdramCapacity, U32 busWidth, U32 sdramDevWidth, U32 numbRanks);
BOOL ddriSpdIsCasLatencySupported(PTR_DDRI_DDR3_SPD_DATA pSpd, U8 CasLat);
BOOL ddriSpdIsVoltageSupported(PTR_DDRI_DDR3_SPD_DATA pSpd, U8 VoltType);
BOOL ddriSpdIsEccSupported(PTR_DDRI_DDR3_SPD_DATA pSpd);
BOOL ddriSpdIsExtendedTempRangeSupported(PTR_DDRI_DDR3_SPD_DATA pSpd);
BOOL ddriSpdIsThermalSensorSupported(PTR_DDRI_DDR3_SPD_DATA pSpd);
BOOL ddriSpdIsChecksumCorrect(PTR_DDRI_DDR3_SPD_DATA pSpd);
U32 ddriSpdGetNumbOfBytesUsed(PTR_DDRI_DDR3_SPD_DATA pSpd);
void ddriHandleMcError(void);
void ddriHandleBogusMcError(void);
U32 ddriGetMcErrorStatus(void);
void ddriHandleMemPortError(void);
void ddriHandleBogusMemPortError(void);
void ddriSetupPsmPb(void);
#if (COBRA_SUPPORT == FALSE)
void ddriEnterSelfRefreshLowPowerMode(void);
void ddriSetupEntryLpMode(U32 flags, BOOL autoEntry, U32 idleCount);
#endif
U32 ddriEnableForceEccError(U8 EccErrorType);
void ddriDisableForceEccError(void);
U32 initDDRController(void *ptrSpd, U32 *pMemorySizeMegaBytes, DDRINIT_MEM_INFO *PtrMem, U32 memFreq, U32 flags);
U32 ddriDoBIST(PU8 startingAddress, U32 memorySize, BOOL addrCheck, BOOL dataCheck);
#if (COBRA_SUPPORT == FALSE)
U32 ddriEccScrubMemory(void);
#endif
void ddriSetPhyTerminationSettings(U32 DpIoVrefSettingSingle, U32 DpIoVrefSettingDual, U32 ApIoSetting);

/* iop uses these for debug only - see ddr3dbg.c file */
void ddriDpResetFifo(void);
void ddriShowGateDelays(void);
void ddriShowPreviousEccErrors(void);
void ddriShowCurrentEccErrorRegs(void);
void ddriDisableAllPhyTracking(void);
U32 ddriGetCurrentEccErrorInfo(PTR_DDRI_DDR3_ECC_INFO PtrEccInfo);

#endif  /* if not defined ddriprotos-h-included */

