/***************************************************************************
 *                                                                         *
 *  Copyright 2011 LSI Corporation.  All rights reserved.                  *
 *                                                                         *
 *  This file is confidential and a trade secret of LSI Corp. The          *
 *  receipt of or possession of this file does not convey any rights to    *
 *  reproduce or disclose its contents or to manufacture, use, or sell     *
 *  anything it may describe, in whole, or in part, without the specific   *
 *  written consent of LSI Corporation.                                    *
 *                                                                         *
 ***************************************************************************
 *
 *           Name:  onfi.h
 *          Title:  ONFI defines
 *     Programmer:  Thibash Rajamani
 *  Creation Date:  June 7, 2011
 *
 *
 * Description
 * -----------
 *   Contains defines for the ONFI Flash Controller.
 *
 *-------------------------------------------------------------------------
 */

#ifndef ONFI_H_SOURCE
#define ONFI_H_SOURCE

/****************************************************************************
 *
 *   ONFI Debug Prints
 *
 ****************************************************************************/

#define ENABLE_ONFI_DEBUG_PRINTS_INIT                   (0)
#define ENABLE_ONFI_DEBUG_PRINTS_REG                    (0)
#define ENABLE_ONFI_DEBUG_PRINTS_MAP_CMD                (0)
#define ENABLE_ONFI_DEBUG_PRINTS_MEM_OFFLOAD            (1)
#define TEST_ONFI_MIRRORING                             (0)

#if ENABLE_ONFI_DEBUG_PRINTS_INIT
  #define ONFI_INIT_DEBUG_PRINT0(format)                iopiDiagConsolePrint0((char*)format)
  #define ONFI_INIT_DEBUG_PRINT1(format,a)              iopiDiagConsolePrint1((char*)format,(U32)a)
  #define ONFI_INIT_DEBUG_PRINT2(format,a,b)            iopiDiagConsolePrint2((char*)format,(U32)a,(U32)b)
  #define ONFI_INIT_DEBUG_PRINT3(format,a,b,c)          iopiDiagConsolePrint3((char*)format,(U32)a,(U32)b,(U32)c)
  #define ONFI_INIT_DEBUG_PRINT4(format,a,b,c,d)        iopiDiagConsolePrint4((char*)format,(U32)a,(U32)b,(U32)c,(U32)d)
#else
  #define ONFI_INIT_DEBUG_PRINT0(format)
  #define ONFI_INIT_DEBUG_PRINT1(format,a)
  #define ONFI_INIT_DEBUG_PRINT2(format,a,b)
  #define ONFI_INIT_DEBUG_PRINT3(format,a,b,c)
  #define ONFI_INIT_DEBUG_PRINT4(format,a,b,c,d)
#endif

#if ENABLE_ONFI_DEBUG_PRINTS_REG
  #define ONFI_REG_DEBUG_PRINT0(format)                 iopiDiagConsolePrint0((char*)format)
  #define ONFI_REG_DEBUG_PRINT1(format,a)               iopiDiagConsolePrint1((char*)format,(U32)a)
  #define ONFI_REG_DEBUG_PRINT2(format,a,b)             iopiDiagConsolePrint2((char*)format,(U32)a,(U32)b)
  #define ONFI_REG_DEBUG_PRINT3(format,a,b,c)           iopiDiagConsolePrint3((char*)format,(U32)a,(U32)b,(U32)c)
  #define ONFI_REG_DEBUG_PRINT4(format,a,b,c,d)         iopiDiagConsolePrint4((char*)format,(U32)a,(U32)b,(U32)c,(U32)d)
#else
  #define ONFI_REG_DEBUG_PRINT0(format)
  #define ONFI_REG_DEBUG_PRINT1(format,a)
  #define ONFI_REG_DEBUG_PRINT2(format,a,b)
  #define ONFI_REG_DEBUG_PRINT3(format,a,b,c)
  #define ONFI_REG_DEBUG_PRINT4(format,a,b,c,d)
#endif

#if ENABLE_ONFI_DEBUG_PRINTS_MAP_CMD
  #define ONFI_MAP_CMD_DEBUG_PRINT0(format)                iopiDiagConsolePrint0((char*)format)
  #define ONFI_MAP_CMD_DEBUG_PRINT1(format,a)              iopiDiagConsolePrint1((char*)format,(U32)a)
  #define ONFI_MAP_CMD_DEBUG_PRINT2(format,a,b)            iopiDiagConsolePrint2((char*)format,(U32)a,(U32)b)
  #define ONFI_MAP_CMD_DEBUG_PRINT3(format,a,b,c)          iopiDiagConsolePrint3((char*)format,(U32)a,(U32)b,(U32)c)
  #define ONFI_MAP_CMD_DEBUG_PRINT4(format,a,b,c,d)        iopiDiagConsolePrint4((char*)format,(U32)a,(U32)b,(U32)c,(U32)d)
#else
  #define ONFI_MAP_CMD_DEBUG_PRINT0(format)
  #define ONFI_MAP_CMD_DEBUG_PRINT1(format,a)
  #define ONFI_MAP_CMD_DEBUG_PRINT2(format,a,b)
  #define ONFI_MAP_CMD_DEBUG_PRINT3(format,a,b,c)
  #define ONFI_MAP_CMD_DEBUG_PRINT4(format,a,b,c,d)
#endif

#if ENABLE_ONFI_DEBUG_PRINTS_MEM_OFFLOAD
  #define ONFI_MEM_OFFLOAD_DEBUG_PRINT0(format)                iopiDiagConsolePrint0((char*)format)
  #define ONFI_MEM_OFFLOAD_DEBUG_PRINT1(format,a)              iopiDiagConsolePrint1((char*)format,(U32)a)
  #define ONFI_MEM_OFFLOAD_DEBUG_PRINT2(format,a,b)            iopiDiagConsolePrint2((char*)format,(U32)a,(U32)b)
  #define ONFI_MEM_OFFLOAD_DEBUG_PRINT3(format,a,b,c)          iopiDiagConsolePrint3((char*)format,(U32)a,(U32)b,(U32)c)
  #define ONFI_MEM_OFFLOAD_DEBUG_PRINT4(format,a,b,c,d)        iopiDiagConsolePrint4((char*)format,(U32)a,(U32)b,(U32)c,(U32)d)
#else
  #define ONFI_MEM_OFFLOAD_DEBUG_PRINT0(format)
  #define ONFI_MEM_OFFLOAD_DEBUG_PRINT1(format,a)
  #define ONFI_MEM_OFFLOAD_DEBUG_PRINT2(format,a,b)
  #define ONFI_MEM_OFFLOAD_DEBUG_PRINT3(format,a,b,c)
  #define ONFI_MEM_OFFLOAD_DEBUG_PRINT4(format,a,b,c,d)
#endif

/****************************************************************************
 *
 *   Clock Configuration and Reset Module Defines
 *
 ****************************************************************************/

#define CCR_REG_ADDR                                (0x0000E000)
#define CCR_SDRAM_DATA_RETENTION_CTRL               (CCR_REG_ADDR + 0x3F) /* SDRAM Data Retention Control */
#define CCR_SDRAM_DATA_RETENTION_CTRL_IFB_MASK      (0x00000001)
#define CCR_SDRAM_DATA_RETENTION_CTRL_SDDVAL_MASK   (0x00000002)
#define CCR_SDRAM_DATA_RETENTION_CTRL_IFCPLEN_MASK  (0x00000080)

/****************************************************************************
 *
 *   Memory Sub System Defines
 *
 ****************************************************************************/

#ifndef MSS_REG_ADDR
#define MSS_REG_ADDR                                        (0x20000) /* DCR Base Address */

#define MSS_MO_FC_CMD_DATA_0_0                              (MSS_REG_ADDR + 0x0100)
#define MSS_MO_FC_CMD_ADDR_0                                (MSS_REG_ADDR + 0x0108)
#define MSS_MO_FC_WRT_DATA_LO_0                             (MSS_REG_ADDR + 0x0104)
#define MSS_MO_FC_WRT_DATA_HI_0                             (MSS_REG_ADDR + 0x0105)
#define MSS_MO_FC_RD_DATA_LO_0                              (MSS_REG_ADDR + 0x0106)
#define MSS_MO_FC_RD_DATA_HI_0                              (MSS_REG_ADDR + 0x0107)

/* MO_DESC_ADDR_LO_0 - Offset 0x0120 */
#define MSS_MO_DESC_ADDR_LO_0                                           (MSS_REG_ADDR + 0x0120)
#define MSS_MO_DESC_ADDR_LO_0_DESC_CHAIN_START_ADDR_LO_MASK             (0xFFFFFFFF)
#define MSS_MO_DESC_ADDR_LO_0_DESC_CHAIN_START_ADDR_LO_SHIFT            ( 0)

/* MO_DESC_ADDR_HI_0 - Offset 0x0121 */
#define MSS_MO_DESC_ADDR_HI_0                                           (MSS_REG_ADDR + 0x0121)
#define MSS_MO_DESC_ADDR_HI_0_DESC_CHAIN_START_ADDR_HI_MASK             (0x0000FFFF)
#define MSS_MO_DESC_ADDR_HI_0_DESC_CHAIN_START_ADDR_HI_SHIFT            ( 0)
#define MSS_MO_DESC_ADDR_HI_0_DESC_CHAIN_VALID_MASK                     (0x00010000)
#define MSS_MO_DESC_ADDR_HI_0_DESC_CHAIN_VALID_SHIFT                    (16)
#define MSS_MO_DESC_ADDR_HI_0_RESERVED0_MASK                            (0xFFFE0000)
#define MSS_MO_DESC_ADDR_HI_0_RESERVED0_SHIFT                           (17)

/* MO_DESC_ADDR_LO_1 - Offset 0x0124 */
#define MSS_MO_DESC_ADDR_LO_1                                           (MSS_REG_ADDR + 0x0124)
#define MSS_MO_DESC_ADDR_LO_1_DESC_CHAIN_START_ADDR_LO_MASK             (0xFFFFFFFF)
#define MSS_MO_DESC_ADDR_LO_1_DESC_CHAIN_START_ADDR_LO_SHIFT            ( 0)

/* MO_DESC_ADDR_HI_1 - Offset 0x0125 */
#define MSS_MO_DESC_ADDR_HI_1                                           (MSS_REG_ADDR + 0x0125)
#define MSS_MO_DESC_ADDR_HI_1_DESC_CHAIN_START_ADDR_HI_MASK             (0x0000FFFF)
#define MSS_MO_DESC_ADDR_HI_1_DESC_CHAIN_START_ADDR_HI_SHIFT            ( 0)
#define MSS_MO_DESC_ADDR_HI_1_DESC_CHAIN_VALID_MASK                     (0x00010000)
#define MSS_MO_DESC_ADDR_HI_1_DESC_CHAIN_VALID_SHIFT                    (16)
#define MSS_MO_DESC_ADDR_HI_1_RESERVED0_MASK                            (0xFFFE0000)
#define MSS_MO_DESC_ADDR_HI_1_RESERVED0_SHIFT                           (17)

/* MO_DESC_ADDR_LO_2 - Offset 0x0128 */
#define MSS_MO_DESC_ADDR_LO_2                                           (MSS_REG_ADDR + 0x0128)
#define MSS_MO_DESC_ADDR_LO_2_DESC_CHAIN_START_ADDR_LO_MASK             (0xFFFFFFFF)
#define MSS_MO_DESC_ADDR_LO_2_DESC_CHAIN_START_ADDR_LO_SHIFT            ( 0)

/* MO_DESC_ADDR_HI_2 - Offset 0x0129 */
#define MSS_MO_DESC_ADDR_HI_2                                           (MSS_REG_ADDR + 0x0129)
#define MSS_MO_DESC_ADDR_HI_2_DESC_CHAIN_START_ADDR_HI_MASK             (0x0000FFFF)
#define MSS_MO_DESC_ADDR_HI_2_DESC_CHAIN_START_ADDR_HI_SHIFT            ( 0)
#define MSS_MO_DESC_ADDR_HI_2_DESC_CHAIN_VALID_MASK                     (0x00010000)
#define MSS_MO_DESC_ADDR_HI_2_DESC_CHAIN_VALID_SHIFT                    (16)
#define MSS_MO_DESC_ADDR_HI_2_RESERVED0_MASK                            (0xFFFE0000)
#define MSS_MO_DESC_ADDR_HI_2_RESERVED0_SHIFT                           (17)

/* MO_DESC_ADDR_LO_3 - Offset 0x012C */
#define MSS_MO_DESC_ADDR_LO_3                                           (MSS_REG_ADDR + 0x012C)
#define MSS_MO_DESC_ADDR_LO_3_DESC_CHAIN_START_ADDR_LO_MASK             (0xFFFFFFFF)
#define MSS_MO_DESC_ADDR_LO_3_DESC_CHAIN_START_ADDR_LO_SHIFT            ( 0)

/* MO_DESC_ADDR_HI_3 - Offset 0x012D */
#define MSS_MO_DESC_ADDR_HI_3                                           (MSS_REG_ADDR + 0x012D)
#define MSS_MO_DESC_ADDR_HI_3_DESC_CHAIN_START_ADDR_HI_MASK             (0x0000FFFF)
#define MSS_MO_DESC_ADDR_HI_3_DESC_CHAIN_START_ADDR_HI_SHIFT            ( 0)
#define MSS_MO_DESC_ADDR_HI_3_DESC_CHAIN_VALID_MASK                     (0x00010000)
#define MSS_MO_DESC_ADDR_HI_3_DESC_CHAIN_VALID_SHIFT                    (16)
#define MSS_MO_DESC_ADDR_HI_3_RESERVED0_MASK                            (0xFFFE0000)
#define MSS_MO_DESC_ADDR_HI_3_RESERVED0_SHIFT                           (17)

/* MO_DESC_ADDR_LO_4 - Offset 0x0130 */
#define MSS_MO_DESC_ADDR_LO_4                                           (MSS_REG_ADDR + 0x0130)
#define MSS_MO_DESC_ADDR_LO_4_DESC_CHAIN_START_ADDR_LO_MASK             (0xFFFFFFFF)
#define MSS_MO_DESC_ADDR_LO_4_DESC_CHAIN_START_ADDR_LO_SHIFT            ( 0)

/* MO_DESC_ADDR_HI_4 - Offset 0x0131 */
#define MSS_MO_DESC_ADDR_HI_4                                           (MSS_REG_ADDR + 0x0131)
#define MSS_MO_DESC_ADDR_HI_4_DESC_CHAIN_START_ADDR_HI_MASK             (0x0000FFFF)
#define MSS_MO_DESC_ADDR_HI_4_DESC_CHAIN_START_ADDR_HI_SHIFT            ( 0)
#define MSS_MO_DESC_ADDR_HI_4_DESC_CHAIN_VALID_MASK                     (0x00010000)
#define MSS_MO_DESC_ADDR_HI_4_DESC_CHAIN_VALID_SHIFT                    (16)
#define MSS_MO_DESC_ADDR_HI_4_RESERVED0_MASK                            (0xFFFE0000)
#define MSS_MO_DESC_ADDR_HI_4_RESERVED0_SHIFT                           (17)

/* MO_DESC_ADDR_LO_5 - Offset 0x0134 */
#define MSS_MO_DESC_ADDR_LO_5                                           (MSS_REG_ADDR + 0x0134)
#define MSS_MO_DESC_ADDR_LO_5_DESC_CHAIN_START_ADDR_LO_MASK             (0xFFFFFFFF)
#define MSS_MO_DESC_ADDR_LO_5_DESC_CHAIN_START_ADDR_LO_SHIFT            ( 0)

/* MO_DESC_ADDR_HI_5 - Offset 0x0135 */
#define MSS_MO_DESC_ADDR_HI_5                                           (MSS_REG_ADDR + 0x0135)
#define MSS_MO_DESC_ADDR_HI_5_DESC_CHAIN_START_ADDR_HI_MASK             (0x0000FFFF)
#define MSS_MO_DESC_ADDR_HI_5_DESC_CHAIN_START_ADDR_HI_SHIFT            ( 0)
#define MSS_MO_DESC_ADDR_HI_5_DESC_CHAIN_VALID_MASK                     (0x00010000)
#define MSS_MO_DESC_ADDR_HI_5_DESC_CHAIN_VALID_SHIFT                    (16)
#define MSS_MO_DESC_ADDR_HI_5_RESERVED0_MASK                            (0xFFFE0000)
#define MSS_MO_DESC_ADDR_HI_5_RESERVED0_SHIFT                           (17)

/* MO_DESC_ADDR_LO_6 - Offset 0x0138 */
#define MSS_MO_DESC_ADDR_LO_6                                           (MSS_REG_ADDR + 0x0138)
#define MSS_MO_DESC_ADDR_LO_6_DESC_CHAIN_START_ADDR_LO_MASK             (0xFFFFFFFF)
#define MSS_MO_DESC_ADDR_LO_6_DESC_CHAIN_START_ADDR_LO_SHIFT            ( 0)

/* MO_DESC_ADDR_HI_6 - Offset 0x0139 */
#define MSS_MO_DESC_ADDR_HI_6                                           (MSS_REG_ADDR + 0x0139)
#define MSS_MO_DESC_ADDR_HI_6_DESC_CHAIN_START_ADDR_HI_MASK             (0x0000FFFF)
#define MSS_MO_DESC_ADDR_HI_6_DESC_CHAIN_START_ADDR_HI_SHIFT            ( 0)
#define MSS_MO_DESC_ADDR_HI_6_DESC_CHAIN_VALID_MASK                     (0x00010000)
#define MSS_MO_DESC_ADDR_HI_6_DESC_CHAIN_VALID_SHIFT                    (16)
#define MSS_MO_DESC_ADDR_HI_6_RESERVED0_MASK                            (0xFFFE0000)
#define MSS_MO_DESC_ADDR_HI_6_RESERVED0_SHIFT                           (17)

/* MO_DESC_ADDR_LO_7 - Offset 0x013C */
#define MSS_MO_DESC_ADDR_LO_7                                           (MSS_REG_ADDR + 0x013C)
#define MSS_MO_DESC_ADDR_LO_7_DESC_CHAIN_START_ADDR_LO_MASK             (0xFFFFFFFF)
#define MSS_MO_DESC_ADDR_LO_7_DESC_CHAIN_START_ADDR_LO_SHIFT            ( 0)

/* MO_DESC_ADDR_HI_7 - Offset 0x013D */
#define MSS_MO_DESC_ADDR_HI_7                                           (MSS_REG_ADDR + 0x013D)
#define MSS_MO_DESC_ADDR_HI_7_DESC_CHAIN_START_ADDR_HI_MASK             (0x0000FFFF)
#define MSS_MO_DESC_ADDR_HI_7_DESC_CHAIN_START_ADDR_HI_SHIFT            ( 0)
#define MSS_MO_DESC_ADDR_HI_7_DESC_CHAIN_VALID_MASK                     (0x00010000)
#define MSS_MO_DESC_ADDR_HI_7_DESC_CHAIN_VALID_SHIFT                    (16)
#define MSS_MO_DESC_ADDR_HI_7_RESERVED0_MASK                            (0xFFFE0000)
#define MSS_MO_DESC_ADDR_HI_7_RESERVED0_SHIFT                           (17)

/* MSS_MO_RESTORE_DIS_LO - Offset 0x0140 */
#define MSS_MO_RESTORE_DIS_LO                                           (MSS_REG_ADDR + 0x0140)
#define MSS_MO_RESTORE_DIS_LO_DATA_INTEGRITY_SIGNATURE_LO_MASK          (0xFFFFFFFF)
#define MSS_MO_RESTORE_DIS_LO_DATA_INTEGRITY_SIGNATURE_LO_SHIFT         ( 0)

/* MSS_MO_RESTORE_DIS_HI - Offset 0x0141 */
#define MSS_MO_RESTORE_DIS_HI                                           (MSS_REG_ADDR + 0x0141)
#define MSS_MO_RESTORE_DIS_HI_DATA_INTEGRITY_SIGNATURE_HI_MASK          (0xFFFFFFFF)
#define MSS_MO_RESTORE_DIS_HI_DATA_INTEGRITY_SIGNATURE_HI_SHIFT         ( 0)

/* MSS_MO_ENCRYPTION_KEY_0 - Offset 0x0144 */
#define MSS_MO_ENCRYPTION_KEY_0                                         (MSS_REG_ADDR + 0x0144)
#define MSS_MO_ENCRYPTION_KEY_0_MASK                                    (0xFFFFFFFF)
#define MSS_MO_ENCRYPTION_KEY_0_SHIFT                                   ( 0)

/* MSS_MO_ENCRYPTION_KEY_1 - Offset 0x0145 */
#define MSS_MO_ENCRYPTION_KEY_1                                         (MSS_REG_ADDR + 0x0145)
#define MSS_MO_ENCRYPTION_KEY_1_MASK                                    (0xFFFFFFFF)
#define MSS_MO_ENCRYPTION_KEY_1_SHIFT                                   ( 0)

/* MSS_MO_ENCRYPTION_KEY_2 - Offset 0x0146 */
#define MSS_MO_ENCRYPTION_KEY_2                                         (MSS_REG_ADDR + 0x0146)
#define MSS_MO_ENCRYPTION_KEY_2_MASK                                    (0xFFFFFFFF)
#define MSS_MO_ENCRYPTION_KEY_2_SHIFT                                   ( 0)

/* MSS_MO_ENCRYPTION_KEY_3 - Offset 0x0147 */
#define MSS_MO_ENCRYPTION_KEY_3                                         (MSS_REG_ADDR + 0x0147)
#define MSS_MO_ENCRYPTION_KEY_3_MASK                                    (0xFFFFFFFF)
#define MSS_MO_ENCRYPTION_KEY_3_SHIFT                                   ( 0)

/* MSS_MO_CTL - Offset 0x0150 */
#define MSS_MO_CTL                                                      (MSS_REG_ADDR + 0x0150)
#define MSS_MO_CTL_RESTORE_BEGIN_MASK                                   (0x00000001)
#define MSS_MO_CTL_RESTORE_BEGIN_SHIFT                                  ( 0)
#define MSS_MO_CTL_GEN_RESTORE_INT_MASK                                 (0x00000002)
#define MSS_MO_CTL_GEN_RESTORE_INT_SHIFT                                ( 1)
#define MSS_MO_CTL_DIS_RESET_MASK                                       (0x00000004)
#define MSS_MO_CTL_DIS_RESET_SHIFT                                      ( 2)
#define MSS_MO_CTL_ONFI_FLUSH_DISABLE_MASK                              (0x00000008)
#define MSS_MO_CTL_ONFI_FLUSH_DISABLE_SHIFT                             ( 3)
#define MSS_MO_CTL_RESTORE_DATA_INTEGRITY_CS_MASK                       (0x00000070)
#define MSS_MO_CTL_RESTORE_DATA_INTEGRITY_CS_SHIFT                      ( 4)
#define MSS_MO_CTL_ONFI_FLASH_4X_CLK_DISABLE_MASK                       (0x00000080)
#define MSS_MO_CTL_ONFI_FLASH_4X_CLK_DISABLE_SHIFT                      ( 7)
#define MSS_MO_CTL_ONFI_OFFLD_IGNORE_CORE_INT_MASK                      (0x00000100)
#define MSS_MO_CTL_ONFI_OFFLD_IGNORE_CORE_INT_SHIFT                     ( 8)
#define MSS_MO_CTL_ONFI_OFFLD_IGNORE_L3_INT_MASK                        (0x00000200)
#define MSS_MO_CTL_ONFI_OFFLD_IGNORE_L3_INT_SHIFT                       ( 9)
#define MSS_MO_CTL_ONFI_OFFLD_IGNORE_FLASH_INT_MASK                     (0x00000400)
#define MSS_MO_CTL_ONFI_OFFLD_IGNORE_FLASH_INT_SHIFT                    (10)
#define MSS_MO_CTL_ONFI_OFFLD_IGNORE_DDR_INT_MASK                       (0x00000800)
#define MSS_MO_CTL_ONFI_OFFLD_IGNORE_DDR_INT_SHIFT                      (11)
#define MSS_MO_CTL_FC0_CS0_VALID_MASK                                   (0x00001000)
#define MSS_MO_CTL_FC0_CS0_VALID_SHIFT                                  (12)
#define MSS_MO_CTL_FC0_CS1_VALID_MASK                                   (0x00002000)
#define MSS_MO_CTL_FC0_CS1_VALID_SHIFT                                  (13)
#define MSS_MO_CTL_FC0_CS2_VALID_MASK                                   (0x00004000)
#define MSS_MO_CTL_FC0_CS2_VALID_SHIFT                                  (14)
#define MSS_MO_CTL_FC0_CS3_VALID_MASK                                   (0x00008000)
#define MSS_MO_CTL_FC0_CS3_VALID_SHIFT                                  (15)
#define MSS_MO_CTL_FC1_CS0_VALID_MASK                                   (0x00010000)
#define MSS_MO_CTL_FC1_CS0_VALID_SHIFT                                  (16)
#define MSS_MO_CTL_FC1_CS1_VALID_MASK                                   (0x00020000)
#define MSS_MO_CTL_FC1_CS1_VALID_SHIFT                                  (17)
#define MSS_MO_CTL_FC1_CS2_VALID_MASK                                   (0x00040000)
#define MSS_MO_CTL_FC1_CS2_VALID_SHIFT                                  (18)
#define MSS_MO_CTL_FC1_CS3_VALID_MASK                                   (0x00080000)
#define MSS_MO_CTL_FC1_CS3_VALID_SHIFT                                  (19)
#define MSS_MO_CTL_ONFI_ONE_CLOCK_WEBAR_MASK                            (0x00100000)
#define MSS_MO_CTL_ONFI_ONE_CLOCK_WEBAR_SHIFT                           (20)
#define MSS_MO_CTL_ONFI_TWO_CLOCK_REBAR_MASK                            (0x00200000)
#define MSS_MO_CTL_ONFI_TWO_CLOCK_REBAR_SHIFT                           (21)
#define MSS_MO_CTL_ONFI_CONTROLLER0_ASSERT_IDLE_MASK                    (0x00400000)
#define MSS_MO_CTL_ONFI_CONTROLLER0_ASSERT_IDLE_SHIFT                   (22)
#define MSS_MO_CTL_ONFI_CONTROLLER1_ASSERT_IDLE_MASK                    (0x00800000)
#define MSS_MO_CTL_ONFI_CONTROLLER1_ASSERT_IDLE_SHIFT                   (23)
#define MSS_MO_CTL_FC0_DFI_INIT_COMPLETE_MASK                           (0x01000000)
#define MSS_MO_CTL_FC0_DFI_INIT_COMPLETE_SHIFT                          (24)
#define MSS_MO_CTL_FC1_DFI_INIT_COMPLETE_MASK                           (0x02000000)
#define MSS_MO_CTL_FC1_DFI_INIT_COMPLETE_SHIFT                          (25)
#define MSS_MO_CTL_MAN_GATEON_MASK                                      (0x04000000)
#define MSS_MO_CTL_MAN_GATEON_SHIFT                                     (26)
#define MSS_MO_CTL_DISABLE_CORE_ISO_MASK                                (0x08000000)
#define MSS_MO_CTL_DISABLE_CORE_ISO_SHIFT                               (27)
#define MSS_MO_CTL_DISABLE_ISO_READY_MASK                               (0x10000000)
#define MSS_MO_CTL_DISABLE_ISO_READY_SHIFT                              (28)
#define MSS_MO_CTL_DISABLE_TMUX_ISOLATION_MASK                          (0x20000000)
#define MSS_MO_CTL_DISABLE_TMUX_ISOLATION_SHIFT                         (29)
#define MSS_MO_CTL_OFFLOAD_PAUSE_EN_MASK                                (0x40000000)
#define MSS_MO_CTL_OFFLOAD_PAUSE_EN_SHIFT                               (30)
#define MSS_MO_CTL_OFFLOAD_SM_RESET_MASK                                (0x80000000)
#define MSS_MO_CTL_OFFLOAD_SM_RESET_SHIFT                               (31)

/* MSS_MO_CHECKSUM_INIT - Offset 0x0151 */
#define MSS_MO_CHECKSUM_INIT                                            (MSS_REG_ADDR + 0x0151)
#define MSS_MO_CHECKSUM_INIT_DIS_CHECKSUM_INIT_VALUE_MASK               (0xFFFFFFFF)
#define MSS_MO_CHECKSUM_INIT_DIS_CHECKSUM_INIT_VALUE_SHIFT              ( 0)


/* MSS_MO_INT_MASK/STAT - Offset 0x0153/0x154 */
#define MSS_MO_INT_MASK                                     (MSS_REG_ADDR + 0x0153)
#define MSS_MO_INT_STAT                                     (MSS_REG_ADDR + 0x0154)
#define MSS_MO_INT_STAT_FC0_CMD_DONE_INT_STAT_MASK          (0x00000001)
#define MSS_MO_INT_STAT_FC0_CMD_DONE_INT_STAT_SHIFT         ( 0)
#define MSS_MO_INT_STAT_FC0_WRDATA_EMPTY_INT_STAT_MASK      (0x00000002)
#define MSS_MO_INT_STAT_FC0_WRDATA_EMPTY_INT_STAT_SHIFT     ( 1)
#define MSS_MO_INT_STAT_FC0_RDDATA_FULL_INT_STAT_MASK       (0x00000004)
#define MSS_MO_INT_STAT_FC0_RDDATA_FULL_INT_STAT_SHIFT      ( 2)
#define MSS_MO_INT_STAT_FC0_TARGET_RDERR_INT_STAT_MASK      (0x00000008)
#define MSS_MO_INT_STAT_FC0_TARGET_RDERR_INT_STAT_SHIFT     ( 3)
#define MSS_MO_INT_STAT_FC0_TARGET_WRERR_INT_STAT_MASK      (0x00000010)
#define MSS_MO_INT_STAT_FC0_TARGET_WRERR_INT_STAT_SHIFT     ( 4)
#define MSS_MO_INT_STAT_FC0_DDR3_RDERR_INT_STAT_MASK        (0x00000020)
#define MSS_MO_INT_STAT_FC0_DDR3_RDERR_INT_STAT_SHIFT       ( 5)
#define MSS_MO_INT_STAT_FC0_DDR3_WRERR_INT_STAT_MASK        (0x00000040)
#define MSS_MO_INT_STAT_FC0_DDR3_WRERR_INT_STAT_SHIFT       ( 6)
#define MSS_MO_INT_STAT_FC1_CMD_DONE_INT_STAT_MASK          (0x00000080)
#define MSS_MO_INT_STAT_FC1_CMD_DONE_INT_STAT_SHIFT         ( 7)
#define MSS_MO_INT_STAT_FC1_WRDATA_EMPTY_INT_STAT_MASK      (0x00000100)
#define MSS_MO_INT_STAT_FC1_WRDATA_EMPTY_INT_STAT_SHIFT     ( 8)
#define MSS_MO_INT_STAT_FC1_RDDATA_FULL_INT_STAT_MASK       (0x00000200)
#define MSS_MO_INT_STAT_FC1_RDDATA_FULL_INT_STAT_SHIFT      ( 9)
#define MSS_MO_INT_STAT_FC1_TARGET_RDERR_INT_STAT_MASK      (0x00000400)
#define MSS_MO_INT_STAT_FC1_TARGET_RDERR_INT_STAT_SHIFT     (10)
#define MSS_MO_INT_STAT_FC1_TARGET_WRERR_INT_STAT_MASK      (0x00000800)
#define MSS_MO_INT_STAT_FC1_TARGET_WRERR_INT_STAT_SHIFT     (11)
#define MSS_MO_INT_STAT_FC1_DDR3_RDERR_INT_STAT_MASK        (0x00001000)
#define MSS_MO_INT_STAT_FC1_DDR3_RDERR_INT_STAT_SHIFT       (12)
#define MSS_MO_INT_STAT_FC1_DDR3_WRERR_INT_STAT_MASK        (0x00002000)
#define MSS_MO_INT_STAT_FC1_DDR3_WRERR_INT_STAT_SHIFT       (13)
#define MSS_MO_INT_STAT_RESTORE_COMPLETE_INT_STAT_MASK      (0x00004000)
#define MSS_MO_INT_STAT_RESTORE_COMPLETE_INT_STAT_SHIFT     (14)
#define MSS_MO_INT_STAT_DDR3_RDATA_PERR_INT_STAT_MASK       (0x00008000)
#define MSS_MO_INT_STAT_DDR3_RDATA_PERR_INT_STAT_SHIFT      (15)
#define MSS_MO_INT_STAT_FC0_IDLE_INT_STAT_MASK              (0x00010000)
#define MSS_MO_INT_STAT_FC0_IDLE_INT_STAT_SHIFT             (16)
#define MSS_MO_INT_STAT_FC1_IDLE_INT_STAT_MASK              (0x00020000)
#define MSS_MO_INT_STAT_FC1_IDLE_INT_STAT_SHIFT             (17)
#define MSS_MO_INT_STAT_RESERVED0_MASK                      (0xFFFC0000)
#define MSS_MO_INT_STAT_RESERVED0_SHIFT                     (18)
#endif

/****************************************************************************
 *
 *   ONFI Defines
 *
 ****************************************************************************/

#define ONFI_MO_FLASH_RST                           (MSS_REG_ADDR + 0x0A08)
#define ONFI_MO_CMD_DATA_REG_OFFSET                 (0x10)
#define ONFI_MO_CMD_ADDR_REG_OFFSET                 (0x10)
#define ONFI_MO_FC_READ_DATA_REG_OFFSET             (0x10)
#define ONFI_MO_FC_WRITE_DATA_REG_OFFSET            (0x10)
#define ONFI_MO_INT_STAT_OFFSET                     (0x7)
#define ONFI_MO_DESC_ADDR_CHANNEL_OFFSET            (0x10)
#define ONFI_MO_DESC_ADDR_BANK_OFFSET               (0x4)
#define ONFI_MO_RESTORE_DATA_INTEGRITY_BANK_OFFSET  (0x4)

#define ONFI_FC0_DFI_INIT_COMPLETE_SHIFT            (24)
#define ONFI_INT_MON_CYCCNT_VALUE                   (10)
#define ONFI_SPARE_AREA_SKIP_COUNT                  (8)    /* value depends on the number of bytes used for internal use */
#define ONFI_FC_POR_RESET_COUNT_VALUE               (0x10)
#define ONFI_FC_BURST_LENGTH                        (64)

/* spare area data pattern which indicates a bad block */
#define BAD_BLOCK_SPARE_AREA_DATA_ONFI    0x0
#define BAD_BLOCK_SPARE_AREA_DATA_NONONFI 0xFF

/* Unique number to identify that the specified area in flash contains the bad block list */
#define ONFI_BAD_BLOCK_LIST_SIGNATURE               (0x600DF00D)

/* Data Integrity Signature */
#define ONFI_DMA_MEM_ADDR_FLASH_CHIP_SELECT         (0x00000700)
#define ONFI_DMA_MEM_ADDR_SIGNATURE_GENERATION      (0x00000800)
#define ONFI_DMA_MEM_ADDR_SIGNATURE_OFFLOAD         (0x00001000)
#define ONFI_DMA_MEM_ADDR_SIGNATURE_RESET           (0x00002000)
#define ONFI_DMA_MEM_ADDR_ENCRY_DECRY               (0x00004000)
#define ONFI_DMA_MEM_ADDR_LAST_DESC                 (0x00008000)

/****************************************************************************
 *
 *   ONFI Flash Controller Registers
 *
 ****************************************************************************/

#define ONFI_FC_REG_OFFSET                              (0x1000)
#define ONFI_BASE_REG                                   (MSS_REG_ADDR + ONFI_FC_REG_OFFSET)
#define ONFI_FC_REG_BASE(fc)                            (ONFI_BASE_REG + ONFI_FC_REG_OFFSET * (fc))

#define ONFI_FC_DEVICE_RESET_BANK0_MASK                 (0x00000001)
#define ONFI_FC_DEVICE_RESET_BANK1_MASK                 (0x00000002)
#define ONFI_FC_DEVICE_RESET_BANK2_MASK                 (0x00000004)
#define ONFI_FC_DEVICE_RESET_BANK3_MASK                 (0x00000008)

#define ONFI_FC_RB_PIN_ENABLED(fc)                      (ONFI_FC_REG_BASE(fc) + (0x0060/4))
#define ONFI_FC_RB_PIN_ENABLED_BANK0_SHIFT              (0)
#define ONFI_FC_RB_PIN_ENABLED_BANK0_MASK               (0x00000001)
#define ONFI_FC_RB_PIN_ENABLED_BANK1_SHIFT              (1)
#define ONFI_FC_RB_PIN_ENABLED_BANK1_MASK               (0x00000002)
#define ONFI_FC_RB_PIN_ENABLED_BANK2_SHIFT              (2)
#define ONFI_FC_RB_PIN_ENABLED_BANK2_MASK               (0x00000004)
#define ONFI_FC_RB_PIN_ENABLED_BANK3_SHIF               (3)
#define ONFI_FC_RB_PIN_ENABLED_BANK3_MASK               (0x00000008)
#define ONFI_FC_RB_PIN_ENABLED_RESERVED_SHIFT           (4)
#define ONFI_FC_RB_PIN_ENABLED_RESERVED_MASK            (0xFFFFFFF0)

#define ONFI_FC_ECC_ENABLE(fc)                          (ONFI_FC_REG_BASE(fc) + (0x00E0/4))
#define ONFI_FC_ECC_ENABLE_FLAG_SHIFT                   (0)
#define ONFI_FC_ECC_ENABLE_FLAG_MASK                    (0x00000001)
#define ONFI_FC_ECC_ENABLE_RESERVED_SHIFT               (1)
#define ONFI_FC_ECC_ENABLE_RESERVED_MASK                (0xFFFFFFFE)

#define ONFI_FC_PAGES_PER_BLOCK(fc)                     (ONFI_FC_REG_BASE(fc) + (0x0150/4))
#define ONFI_FC_PAGES_PER_BLOCK_VALUE_SHIFT             (0)
#define ONFI_FC_PAGES_PER_BLOCK_VALUE_MASK              (0x0000FFFF)
#define ONFI_FC_PAGES_PER_BLOCK_RESERVED_SHIFT          (16)
#define ONFI_FC_PAGES_PER_BLOCK_RESERVED_MASK           (0xFFFF0000)

#define ONFI_FC_DEVICE_WIDTH(fc)                        (ONFI_FC_REG_BASE(fc) + (0x0160/4))
#define ONFI_FC_DEVICE_WIDTH_VALUE_SHIFT                (0)
#define ONFI_FC_DEVICE_WIDTH_VALUE_MASK                 (0x00000003)
#define ONFI_FC_DEVICE_WIDTH_RESERVED_SHIFT             (2)
#define ONFI_FC_DEVICE_WIDTH_RESERVED_MASK              (0xFFFFFFFC)

#define ONFI_FC_DEVICE_MAIN_AREA_SIZE(fc)               (ONFI_FC_REG_BASE(fc) + (0x0170/4))
#define ONFI_FC_DEVICE_MAIN_AREA_SIZE_VALUE_SHIFT       (0)
#define ONFI_FC_DEVICE_MAIN_AREA_SIZE_VALUE_MASK        (0x0000FFFF)
#define ONFI_FC_DEVICE_MAIN_AREA_SIZE_RESERVED_SHIFT    (16)
#define ONFI_FC_DEVICE_MAIN_AREA_SIZE_RESERVED_MASK     (0xFFFF0000)

#define ONFI_FC_DEVICE_SPARE_AREA_SIZE(fc)              (ONFI_FC_REG_BASE(fc) + (0x0180/4))
#define ONFI_FC_DEVICE_SPARE_AREA_SIZE_VALUE_SHIFT      (0)
#define ONFI_FC_DEVICE_SPARE_AREA_SIZE_VALUE_MASK       (0x0000FFFF)
#define ONFI_FC_DEVICE_SPARE_AREA_SIZE_RESERVED_SHIFT   (16)
#define ONFI_FC_DEVICE_SPARE_AREA_SIZE_RESERVED_MASK    (0xFFFF0000)

#define ONFI_FC_POR_RESET_COUNT(fc)                     (ONFI_FC_REG_BASE(fc) + (0x02A0/4))
#define ONFI_FC_POR_RESET_COUNT_VALUE_SHIFT             (0)
#define ONFI_FC_POR_RESET_COUNT_VALUE_MASK              (0x0000FFFF)
#define ONFI_FC_POR_RESET_COUNT_RESERVED_SHIFT          (16)
#define ONFI_FC_POR_RESET_COUNT_RESERVED_MASK           (0xFFFF0000)

#define ONFI_FC_DEVICE_RESET(fc)                        (ONFI_FC_REG_BASE(fc) + 0x0/4)
#define ONFI_FC_REVISION(fc)                            (ONFI_FC_REG_BASE(fc) + 0x370/4)

#define ONFI_FC_INTR_STATUS(fc,bank)                        (ONFI_FC_REG_BASE(fc) + (0x0410 + 0x50 * bank)/4)
#define ONFI_FC_INTR_STATUS_ECC_UNCOR_ERR0_SHIFT            (0)
#define ONFI_FC_INTR_STATUS_ECC_UNCOR_ERR0_MASK             (0x00000001)
#define ONFI_FC_INTR_STATUS_RESERVED0_SHIFT                 (1)
#define ONFI_FC_INTR_STATUS_RESERVED0_MASK                  (0x00000002)
#define ONFI_FC_INTR_STATUS_DMA_CMD_COMP0_SHIFT             (2)
#define ONFI_FC_INTR_STATUS_DMA_CMD_COMP0_MASK              (0x00000004)
#define ONFI_FC_INTR_STATUS_TIME_OUT0_SHIFT                 (3)
#define ONFI_FC_INTR_STATUS_TIME_OUT0_MASK                  (0x00000008)
#define ONFI_FC_INTR_STATUS_PROGRAM_FAIL0_SHIFT             (4)
#define ONFI_FC_INTR_STATUS_PROGRAM_FAIL0_MASK              (0x00000010)
#define ONFI_FC_INTR_STATUS_ERASE_FAIL0_SHIFT               (5)
#define ONFI_FC_INTR_STATUS_ERASE_FAIL0_MASK                (0x00000020)
#define ONFI_FC_INTR_STATUS_LOAD_COMP0_SHIFT                (6)
#define ONFI_FC_INTR_STATUS_LOAD_COMP0_MASK                 (0x00000040)
#define ONFI_FC_INTR_STATUS_PROGRAM_COMP0_SHIFT             (7)
#define ONFI_FC_INTR_STATUS_PROGRAM_COMP0_MASK              (0x00000080)
#define ONFI_FC_INTR_STATUS_ERASE_COMP0_SHIFT               (8)
#define ONFI_FC_INTR_STATUS_ERASE_COMP0_MASK                (0x00000100)
#define ONFI_FC_INTR_STATUS_PIPE_CPYBCK_CMD_COMP0_SHIFT     (9)
#define ONFI_FC_INTR_STATUS_PIPE_CPYBCK_CMD_COMP0_MASK      (0x00000200)
#define ONFI_FC_INTR_STATUS_LOCKED_BLK0_SHIFT               (10)
#define ONFI_FC_INTR_STATUS_LOCKED_BLK0_MASK                (0x00000400)
#define ONFI_FC_INTR_STATUS_UNSUP_CMD0_SHIFT                (11)
#define ONFI_FC_INTR_STATUS_UNSUP_CMD0_MASK                 (0x00000800)
#define ONFI_FC_INTR_STATUS_INT_ACT0_SHIFT                  (12)
#define ONFI_FC_INTR_STATUS_INT_ACT0_MASK                   (0x00001000)
#define ONFI_FC_INTR_STATUS_RST_COMP0_SHIFT                 (13)
#define ONFI_FC_INTR_STATUS_RST_COMP0_MASK                  (0x00002000)
#define ONFI_FC_INTR_STATUS_PIPE_CMD_ERR0_SHIFT             (14)
#define ONFI_FC_INTR_STATUS_PIPE_CMD_ERR0_MASK              (0x00004000)
#define ONFI_FC_INTR_STATUS_PAGE_XFER_INC0_SHIFT            (15)
#define ONFI_FC_INTR_STATUS_PAGE_XFER_INC0_MASK             (0x00008000)
#define ONFI_FC_INTR_STATUS_RESERVED1_SHIFT                 (16)
#define ONFI_FC_INTR_STATUS_RESERVED1_MASK                  (0xFFFF0000)

#define ONFI_FC_INTR_ENABLE(fc,bank)                        (ONFI_FC_REG_BASE(fc) + (0x0420 + 0x50 * bank)/4)
#define ONFI_FC_INTR_ENABLE_ALL                             (0x0000FFFD)
#define ONFI_FC_INTR_ENABLE_ECC_UNCOR_ERR_MASK              (0x00000001)
#define ONFI_FC_INTR_ENABLE_DMA_CMD_COMP_MASK               (0x00000004)
#define ONFI_FC_INTR_ENABLE_TIMEOUT_MASK                    (0x00000008)
#define ONFI_FC_INTR_ENABLE_PROGRAM_FAIL_MASK               (0x00000010)
#define ONFI_FC_INTR_ENABLE_ERASE_FAIL_MASK                 (0x00000020)
#define ONFI_FC_INTR_ENABLE_LOAD_COMP_MASK                  (0x00000040)
#define ONFI_FC_INTR_ENABLE_PROGRAM_COMP_MASK               (0x00000080)
#define ONFI_FC_INTR_ENABLE_ERASE_COMP_MASK                 (0x00000100)
#define ONFI_FC_INTR_ENABLE_PIPE_CPYBCK_CMD_COMP_MASK       (0x00000200)
#define ONFI_FC_INTR_ENABLE_LOCKED_BLK_MASK                 (0x00000400)
#define ONFI_FC_INTR_ENABLE_UNSUP_CMD_MASK                  (0x00000800)
#define ONFI_FC_INTR_ENABLE_INT_ACT_MASK                    (0x00001000)
#define ONFI_FC_INTR_ENABLE_RST_COMP_MASK                   (0x00002000)
#define ONFI_FC_INTR_ENABLE_PIPE_CMD_ERR_MASK               (0x00004000)
#define ONFI_FC_INTR_ENABLE_PAGE_XFER_INC_MASK              (0x00008000)

#define ONFI_FC_PAGE_CNT0(fc,bank)                          (ONFI_FC_REG_BASE(fc) + (0x0430 + 0x50 * bank)/4)
#define ONFI_FC_PAGE_CNT0_SHIFT                             (0)
#define ONFI_FC_PAGE_CNT0_MASK                              (0x000000FF)
#define ONFI_FC_PAGE_CNT0_RESERVED_SHIFT                    (8)
#define ONFI_FC_PAGE_CNT0_RESERVED_MASK                     (0xFFFFFF00)

#define ONFI_FC_ERR_PAGE_ADDR0(fc, bank)                    (ONFI_FC_REG_BASE(fc) + (0x0440 + 0x50 * bank)/4)
#define ONFI_FC_ERR_PAGE_ADDR0_SHIFT                        (0)
#define ONFI_FC_ERR_PAGE_ADDR0_MASK                         (0x0000FFFF)
#define ONFI_FC_ERR_PAGE_ADDR0_RESERVED_SHIFT               (16)
#define ONFI_FC_ERR_PAGE_ADDR0_RESERVED_MASK                (0xFFFF0000)

#define ONFI_FC_ERR_BLOCK_ADDR0(fc, bank)                   (ONFI_FC_REG_BASE(fc) + (0x0450 + 0x50 * bank)/4)
#define ONFI_FC_ERR_BLOCK_ADDR0_SHIFT                       (0)
#define ONFI_FC_ERR_BLOCK_ADDR0_MASK                        (0x0000FFFF)
#define ONFI_FC_ERR_BLOCK_ADDR0_RESERVED_SHIFT              (16)
#define ONFI_FC_ERR_BLOCK_ADDR0_RESERVED_MASK               (0xFFFF0000)

#define ONFI_FP_LOAD_WAIT_CNT(fp)                           (ONFI_FC_REG_BASE(fp) + (0x0020/4))
#define ONFI_FP_LOAD_WAIT_CNT_SHIFT                         (0)
#define ONFI_FP_LOAD_WAIT_CNT_MASK                          (0x000001FF)
#define ONFI_FP_LOAD_WAIT_CNT_RESERVED_SHIFT                (9)
#define ONFI_FP_LOAD_WAIT_CNT_RESERVED_MASK                 (0xFFFFFE00)

#define ONFI_FP_PROGRAM_WAIT_CNT(fp)                        (ONFI_FC_REG_BASE(fp) + (0x0030/4))
#define ONFI_FP_PROGRAM_WAIT_CNT_SHIFT                      (0)
#define ONFI_FP_PROGRAM_WAIT_CNT_MASK                       (0x000001FF)
#define ONFI_FP_PROGRAM_WAIT_CNT_RESERVED_SHIFT             (9)
#define ONFI_FP_PROGRAM_WAIT_CNT_RESERVED_MASK              (0xFFFFFE00)

#define ONFI_FP_ERASE_WAIT_CNT(fp)                          (ONFI_FC_REG_BASE(fp) + (0x0040/4))
#define ONFI_FP_ERASE_WAIT_CNT_SHIFT                        (0)
#define ONFI_FP_ERASE_WAIT_CNT_MASK                         (0x000001FF)
#define ONFI_FP_ERASE_WAIT_CNT_RESERVED_SHIFT               (9)
#define ONFI_FP_ERASE_WAIT_CNT_RESERVED_MASK                (0xFFFFFE00)

#define ONFI_FC_INT_MON_CYCCNT(fc)                          (ONFI_FC_REG_BASE(fc) + (0x0050/4))
#define ONFI_FC_INT_MON_CYCCNT_VALUE_SHIFT                  (0)
#define ONFI_FC_INT_MON_CYCCNT_VALUE_MASK                   (0x0000FFFF)
#define ONFI_FC_INT_MON_CYCCNT_RESERVED_SHIFT               (16)
#define ONFI_FC_INT_MON_CYCCNT_RESERVED_MASK                (0xFFFF0000)

#define ONFI_FC_RB_PIN_ENABLED(fc)                          (ONFI_FC_REG_BASE(fc) + (0x0060/4))
#define ONFI_FC_RB_PIN_ENABLED_BANK0_SHIFT                  (0)
#define ONFI_FC_RB_PIN_ENABLED_BANK0_MASK                   (0x00000001)
#define ONFI_FC_RB_PIN_ENABLED_BANK1_SHIFT                  (1)
#define ONFI_FC_RB_PIN_ENABLED_BANK1_MASK                   (0x00000002)
#define ONFI_FC_RB_PIN_ENABLED_BANK2_SHIFT                  (2)
#define ONFI_FC_RB_PIN_ENABLED_BANK2_MASK                   (0x00000004)
#define ONFI_FC_RB_PIN_ENABLED_BANK3_SHIFT                  (3)
#define ONFI_FC_RB_PIN_ENABLED_BANK3_MASK                   (0x00000008)
#define ONFI_FC_RB_PIN_ENABLED_RESERVED_SHIFT               (4)
#define ONFI_FC_RB_PIN_ENABLED_RESERVED_MASK                (0xFFFFFFF0)

#define ONFI_FC_COPYBACK_DISABLE(fc)                        (ONFI_FC_REG_BASE(fc) + (0x0090/4))
#define ONFI_FC_COPYBACK_DISABLE_FLAG_SHIFT                 (0)
#define ONFI_FC_COPYBACK_DISABLE_FLAG_MASK                  (0x00000001)
#define ONFI_FC_COPYBACK_DISABLE_RESERVED_SHIFT             (1)
#define ONFI_FC_COPYBACK_DISABLE_RESERVED_MASK              (0xFFFFFFFE)

#define ONFI_FC_CHIP_ENABLE_DONT_CARE_ENABLE(fc)            (ONFI_FC_REG_BASE(fc) + (0x00D0/4))
#define ONFI_FC_CHIP_ENABLE_DONT_CARE_ENABLE_FLAG_SHIFT     (0)
#define ONFI_FC_CHIP_ENABLE_DONT_CARE_ENABLE_FLAG_MASK      (0x00000001)
#define ONFI_FC_CHIP_ENABLE_DONT_CARE_ENABLE_RESERVED_SHIFT (1)
#define ONFI_FC_CHIP_ENABLE_DONT_CARE_ENABLE_RESERVED_MASK  (0xFFFFFFFE)

#define ONFI_FC_GLOBAL_INT_ENABLE(fc)                       (ONFI_FC_REG_BASE(fc) + (0x00F0/4))
#define ONFI_FC_GLOBAL_INT_ENABLE_FLAG_SHIFT                (0)
#define ONFI_FC_GLOBAL_INT_ENABLE_FLAG_MASK                 (0x00000001)
#define ONFI_FC_GLOBAL_INT_ENABLE_RESERVED_SHIFT            (1)
#define ONFI_FC_GLOBAL_INT_ENABLE_RESERVED_MASK             (0xFFFFFFFE)

#define ONFI_FC_SPARE_AREA_SKIP_BYTES(fc)                   (ONFI_FC_REG_BASE(fc) + (0x0230/4))
#define ONFI_FC_SPARE_AREA_SKIP_BYTES_VALUE_SHIFT           (0)
#define ONFI_FC_SPARE_AREA_SKIP_BYTES_VALUE_MASK            (0x0000003F)
#define ONFI_FC_SPARE_AREA_SKIP_BYTES_RESERVED_SHIFT        (6)
#define ONFI_FC_SPARE_AREA_SKIP_BYTES_RESERVED_MASK         (0xFFFFFFC0)

#define ONFI_FC_DEVICE_ID(fc)                               (ONFI_FC_REG_BASE(fc) + (0x0310/4))
#define ONFI_FC_DEVICE_ID_VALUE_SHIFT                       (0)
#define ONFI_FC_DEVICE_ID_VALUE_MASK                        (0x000000FF)
#define ONFI_FC_DEVICE_ID_RESERVED_SHIFT                    (8)
#define ONFI_FC_DEVICE_ID_RESERVED_MASK                     (0xFFFFFF00)

#define ONFI_FC_PHY_CNTL_REG(fc)                            (ONFI_FC_REG_BASE(fc) + (0x0F00/4))
#define ONFI_FP_PHY_CONFIG0(fp)                             (ONFI_FC_REG_BASE(fp) + (0x2000/4))

#define ONFI_FC_ONFI_DEVICE_NO_OF_LUNS(fc)                  (ONFI_FC_REG_BASE(fc) + (0x03C0/4))
#define ONFI_FC_NO_OF_LUNS_VALUE_SHIFT                      (0)
#define ONFI_FC_NO_OF_LUNS_VALUE_MASK                       (0x000000FF)
#define ONFI_FC_ONFI_DEVICE_SHIFT                           (8)
#define ONFI_FC_ONFI_DEVICE_MASK                            (0x00000100)
#define ONFI_FC_ONFI_DEVICE_NO_OF_LUNS_RESERVED_SHIFT       (9)
#define ONFI_FC_ONFI_DEVICE_NO_OF_LUNS_RESERVED_MASK        (0xFFFFFE00)

#define ONFI_FC_ONFI_DEVICE_NO_OF_BLOCKS_PER_LUNS_L(fc)     (ONFI_FC_REG_BASE(fc) + (0x03D0/4))
#define ONFI_FC_NO_OF_BLOCKS_L_VALUE_MASK                   (0x0000FFFF)

#define ONFI_FC_FEATURES(fc)                                (ONFI_FC_REG_BASE(fc) + (0x03F0/4))
#define ONFI_FC_FEATURES_NUMBER_OF_BANKS_MASK               (0x00000003)
#define ONFI_FC_FEATURES_ECC_MAX_ERR_MASK                   (0x0000002C)
#define ONFI_FC_FEATURES_DMA_MASK                           (0x00000040)
#define ONFI_FC_FEATURES_CMD_DMA_MASK                       (0x00000080)
#define ONFI_FC_FEATURES_PARTITION_MASK                     (0x00000100)
#define ONFI_FC_FEATURES_XDMA_SIDEBAND_MASK                 (0x00000200)
#define ONFI_FC_FEATURES_GPREG_MASK                         (0x00000400)
#define ONFI_FC_FEATURES_INDEX_ADDR_MASK                    (0x00000800)
#define ONFI_FC_FEATURES_DFI_INTF_MASK                      (0x00001000)
#define ONFI_FC_FEATURES_LBA_MASK                           (0x00002000)

#define ONFI_FC_TRANSFER_MODE(fc)                           (ONFI_FC_REG_BASE(fc) + (0x0400/4))
#define ONFI_FC_TRANSFER_MODE_VALUE0_SHIFT                  (0)
#define ONFI_FC_TRANSFER_MODE_VALUE0_MASK                   (0x0000000F)
#define ONFI_FC_TRANSFER_MODE_VALUE1_SHIFT                  (4)
#define ONFI_FC_TRANSFER_MODE_VALUE1_MASK                   (0x000000F0)
#define ONFI_FC_TRANSFER_MODE_VALUE2_SHIFT                  (8)
#define ONFI_FC_TRANSFER_MODE_VALUE2_MASK                   (0x00000F00)
#define ONFI_FC_TRANSFER_MODE_VALUE3_SHIFT                  (12)
#define ONFI_FC_TRANSFER_MODE_VALUE3_MASK                   (0x0000F000)
#define ONFI_FC_TRANSFER_MODE_RESERVED_SHIFT                (16)
#define ONFI_FC_TRANSFER_MODE_RESERVED_MASK                 (0xFFFFFF00)

#define ONFI_FC_ONFI_DEVICE_NO_OF_BLOCKS_PER_LUNS_H(fc)     (ONFI_FC_REG_BASE(fc) + (0x03E0/4))
#define ONFI_FC_NO_OF_BLOCKS_H_VALUE_MASK                   (0x0000FFFF)

#define ONFI_FC_DMA_ENABLE(fc)                              (ONFI_FC_REG_BASE(fc) + (0x0700/4))
#define ONFI_FC_DMA_ENABLE_FLAG_SHIFT                       (0)
#define ONFI_FC_DMA_ENABLE_FLAG_MASK                        (0x00000001)
#define ONFI_FC_DMA_ENABLE_RESERVED_SHIFT                   (1)
#define ONFI_FC_DMA_ENABLE_RESERVED_MASK                    (0xFFFFFFFE)

#define ONFI_FC_DMA_INTR(fc)                                (ONFI_FC_REG_BASE(fc) + (0x0720/4))
#define ONFI_FC_DMA_INTR_TARGET_ERROR_SHIFT                 (0)
#define ONFI_FC_DMA_INTR_TARGET_ERROR_MASK                  (0x00000001)
#define ONFI_FC_DMA_INTR_DESC_COMP_CHANNEL0_SHIFT           (1)
#define ONFI_FC_DMA_INTR_DESC_COMP_CHANNEL0_MASK            (0x00000002)
#define ONFI_FC_DMA_INTR_DESC_COMP_CHANNEL1_SHIFT           (2)
#define ONFI_FC_DMA_INTR_DESC_COMP_CHANNEL1_MASK            (0x00000004)
#define ONFI_FC_DMA_INTR_DESC_COMP_CHANNEL2_SHIFT           (3)
#define ONFI_FC_DMA_INTR_DESC_COMP_CHANNEL2_MASK            (0x00000008)
#define ONFI_FC_DMA_INTR_DESC_COMP_CHANNEL3_SHIFT           (4)
#define ONFI_FC_DMA_INTR_DESC_COMP_CHANNEL3_MASK            (0x00000010)
#define ONFI_FC_DMA_INTR_MEMCOPY_DESC_COMP_SHIFT            (5)
#define ONFI_FC_DMA_INTR_MEMCOPY_DESC_COMP_MASK             (0x00000020)
#define ONFI_FC_DMA_INTR_CMDDMA_IDLE_SHIFT                  (6)
#define ONFI_FC_DMA_INTR_CMDDMA_IDLE_MASK                   (0x00000040)
#define ONFI_FC_DMA_INTR_RESERVED_SHIFT                     (7)
#define ONFI_FC_DMA_INTR_RESERVED_MASK                      (0xFFFFFF80)

#define ONFI_FC_DMA_INTR_EN(fc)                             (ONFI_FC_REG_BASE(fc) + (0x0730/4))
#define ONFI_FC_DMA_INTR_EN_TARGET_ERROR_SHIFT              (0)
#define ONFI_FC_DMA_INTR_EN_TARGET_ERROR_MASK               (0x00000001)
#define ONFI_FC_DMA_INTR_EN_DESC_COMP_CHANNEL0_SHIFT        (1)
#define ONFI_FC_DMA_INTR_EN_DESC_COMP_CHANNEL0_MASK         (0x00000002)
#define ONFI_FC_DMA_INTR_EN_DESC_COMP_CHANNEL1_SHIFT        (2)
#define ONFI_FC_DMA_INTR_EN_DESC_COMP_CHANNEL1_MASK         (0x00000004)
#define ONFI_FC_DMA_INTR_EN_DESC_COMP_CHANNEL2_SHIFT        (3)
#define ONFI_FC_DMA_INTR_EN_DESC_COMP_CHANNEL2_MASK         (0x00000008)
#define ONFI_FC_DMA_INTR_EN_DESC_COMP_CHANNEL3_SHIFT        (4)
#define ONFI_FC_DMA_INTR_EN_DESC_COMP_CHANNEL3_MASK         (0x00000010)
#define ONFI_FC_DMA_INTR_EN_MEMCOPY_DESC_COMP_SHIFT         (5)
#define ONFI_FC_DMA_INTR_EN_MEMCOPY_DESC_COMP_MASK          (0x00000020)
#define ONFI_FC_DMA_INTR_EN_CMDDMA_IDLE_SHIFT               (6)
#define ONFI_FC_DMA_INTR_EN_CMDDMA_IDLE_MASK                (0x00000040)
#define ONFI_FC_DMA_INTR_EN_RESERVED_SHIFT                  (7)
#define ONFI_FC_DMA_INTR_EN_RESERVED_MASK                   (0xFFFFFF80)

#define ONFI_FC_DMA_INTR_EN_ALL_MASK                        (0x7F)

#define ONFI_FC_TARGET_ERR_ADDR_LO(fc)                      (ONFI_FC_REG_BASE(fc) + (0x0740/4))
#define ONFI_FC_TARGET_ERR_ADDR_LO_VALUE_SHIFT              (0)
#define ONFI_FC_TARGET_ERR_ADDR_LO_VALUE_MASK               (0xFFFFFFFF)

#define ONFI_FC_TARGET_ERR_ADDR_HI(fc)                      (ONFI_FC_REG_BASE(fc) + (0x0750/4))
#define ONFI_FC_TARGET_ERR_ADDR_HI_VALUE_SHIFT              (0)
#define ONFI_FC_TARGET_ERR_ADDR_HI_VALUE_MASK               (0xFFFFFFFF)

#define ONFI_FC_CHNL_ACTIVE(fc)                             (ONFI_FC_REG_BASE(fc) + (0x0760/4))
#define ONFI_FC_CHNL_ACTIVE_CHANNEL0_SHIFT                  (0)
#define ONFI_FC_CHNL_ACTIVE_CHANNEL0_MASK                   (0x00000001)
#define ONFI_FC_CHNL_ACTIVE_CHANNEL1_SHIFT                  (1)
#define ONFI_FC_CHNL_ACTIVE_CHANNEL1_MASK                   (0x00000002)
#define ONFI_FC_CHNL_ACTIVE_CHANNEL2_SHIFT                  (2)
#define ONFI_FC_CHNL_ACTIVE_CHANNEL2_MASK                   (0x00000004)
#define ONFI_FC_CHNL_ACTIVE_CHANNEL3_SHIFT                  (3)
#define ONFI_FC_CHNL_ACTIVE_CHANNEL3_MASK                   (0x00000008)
#define ONFI_FC_CHNL_ACTIVE_RESERVED_SHIFT                  (4)
#define ONFI_FC_CHNL_ACTIVE_RESERVED_MASK                   (0xFFFFFFF0)


#define ONFI_FC_FLASH_BURST_LENGTH(fc)                      (ONFI_FC_REG_BASE(fc) + (0x0770/4))
#define ONFI_FC_FLASH_BURST_LENGTH_VALUE_SHIFT              (0)
#define ONFI_FC_FLASH_BURST_LENGTH_VALUE_MASK               (0x00000003)
#define ONFI_FC_FLASH_BURST_LENGTH_RESERVED_SHIFT           (2)
#define ONFI_FC_FLASH_BURST_LENGTH_RESERVED_MASK            (0xFFFFFFFC)

#define ONFI_FC_CHIP_INTERLEAVE_EN_AND_ALLOW_INT_RD(fc)             (ONFI_FC_REG_BASE(fc) + (0x0780/4))
#define ONFI_FC_CHIP_INTERLEAVE_ENABLE_SHIFT                        (0)
#define ONFI_FC_CHIP_INTERLEAVE_ENABLE_MASK                         (0x00000001)
#define ONFI_FC_CHIP_INTERLEAVE_EN_AND_ALLOW_INT_RD_RESERVED0_SHIFT (1)
#define ONFI_FC_CHIP_INTERLEAVE_EN_AND_ALLOW_INT_RD_RESERVED0_MASK  (0x0000000E)
#define ONFI_FC_ALLOW_INT_READS_WITHIN_LUNS_SHIFT                   (4)
#define ONFI_FC_ALLOW_INT_READS_WITHIN_LUNS_MASK                    (0x00000010)
#define ONFI_FC_CHIP_INTERLEAVE_EN_AND_ALLOW_INT_RD_RESERVED1_SHIFT (5)
#define ONFI_FC_CHIP_INTERLEAVE_EN_AND_ALLOW_INT_RD_RESERVED1_MASK  (0xFFFFFFE0)

#define ONFI_FC_CHIP_RESCAN_BUFFER_FLAG(fc)                 (ONFI_FC_REG_BASE(fc) + (0x0790/4))
#define ONFI_FC_RESCAN_BUFFER_FLAG_SHIFT                    (0)
#define ONFI_FC_RESCAN_BUFFER_FLAG_MASK                     (0x0000000F)
#define ONFI_FC_RESCAN_BUFFER_FLAG_RESERVED_SHIFT           (4)
#define ONFI_FC_RESCAN_BUFFER_FLAG_RESERVED_MASK            (0xFFFFFFF0)

#define ONFI_FC_NO_OF_BLOCKS_PER_LUN(fc)                    (ONFI_FC_REG_BASE(fc) + (0x07A0/4))
#define ONFI_FC_NO_OF_BLOCKS_PER_LUN_VALUE_SHIFT            (0)
#define ONFI_FC_NO_OF_BLOCKS_PER_LUN_VALUE_MASK             (0x0000000F)
#define ONFI_FC_NO_OF_BLOCKS_PER_LUN_RESERVED_SHIFT         (4)
#define ONFI_FC_NO_OF_BLOCKS_PER_LUN_RESERVED_MASK          (0xFFFFFFF0)

#define ONFI_FC_LUN_STATUS_CMD(fc)                          (ONFI_FC_REG_BASE(fc) + (0x07B0/4))
#define ONFI_FC_LUN_STATUS_CMD_VALUE_SHIFT                  (0)
#define ONFI_FC_LUN_STATUS_CMD_VALUE_MASK                   (0x0000FFFF)
#define ONFI_FC_LUN_STATUS_CMD_RESERVED_SHIFT               (16)
#define ONFI_FC_LUN_STATUS_CMD_RESERVED_MASK                (0xFFFF0000)

#define ONFI_FC_CMD_DMA_CHAN_ERROR(fc)                      (ONFI_FC_REG_BASE(fc) + (0x07C0/4))
#define ONFI_FC_CMD_DMA_CHAN_ERR_CHAN0_SHIFT                (0)
#define ONFI_FC_CMD_DMA_CHAN_ERR_CHAN0_MASK                 (0x00000001)
#define ONFI_FC_CMD_DMA_CHAN_ERR_CHAN1_SHIFT                (1)
#define ONFI_FC_CMD_DMA_CHAN_ERR_CHAN1_MASK                 (0x00000002)
#define ONFI_FC_CMD_DMA_CHAN_ERR_CHAN2_SHIFT                (2)
#define ONFI_FC_CMD_DMA_CHAN_ERR_CHAN2_MASK                 (0x00000004)
#define ONFI_FC_CMD_DMA_CHAN_ERR_CHAN3_SHIFT                (3)
#define ONFI_FC_CMD_DMA_CHAN_ERR_CHAN3_MASK                 (0x00000008)
#define ONFI_FC_CMD_DMA_CHAN_ERROR_RESERVED_SHIFT           (4)
#define ONFI_FC_CMD_DMA_CHAN_ERROR_RESERVED_MASK            (0xFFFFFFF0)

#define ONFI_FC_CMD_DMA_CHAN_ERR_EN(fc)                     (ONFI_FC_REG_BASE(fc) + (0x07D0/4))
#define ONFI_FC_CMD_DMA_CHAN_ERR_EN_CHAN0_SHIFT             (0)
#define ONFI_FC_CMD_DMA_CHAN_ERR_EN_CHAN0_MASK              (0x00000001)
#define ONFI_FC_CMD_DMA_CHAN_ERR_EN_CHAN1_SHIFT             (1)
#define ONFI_FC_CMD_DMA_CHAN_ERR_EN_CHAN1_MASK              (0x00000002)
#define ONFI_FC_CMD_DMA_CHAN_ERR_EN_CHAN2_SHIFT             (2)
#define ONFI_FC_CMD_DMA_CHAN_ERR_EN_CHAN2_MASK              (0x00000004)
#define ONFI_FC_CMD_DMA_CHAN_ERR_EN_CHAN3_SHIFT             (3)
#define ONFI_FC_CMD_DMA_CHAN_ERR_EN_CHAN3_MASK              (0x00000008)
#define ONFI_FC_CMD_DMA_CHAN_ERR_EN_RESERVED_SHIFT          (4)
#define ONFI_FC_CMD_DMA_CHAN_ERR_EN_RESERVED_MASK           (0xFFFFFFF0)

#define ONFI_FC_CMD_DMA_CHAN_ERR_EN_ALL_MASK                (0xF)

#define ONFI_FC_ONFI_REVISION_NUMBER(fc)                    (ONFI_FC_REG_BASE(fc) + (0x0B00/4))
#define ONFI_FC_ONFI_REVISION_NUMBER_VALUE_SHIFT            (0)
#define ONFI_FC_ONFI_REVISION_NUMBER_VALUE_MASK             (0x0000000F)
#define ONFI_FC_ONFI_REVISION_NUMBER_RESERVED_SHIFT         (4)
#define ONFI_FC_ONFI_REVISION_NUMBER_RESERVED_MASK          (0xFFFFFFF0)

#define ONFI_FC_ONFI_INTERLEAVED_OP_ATTR(fc)                (ONFI_FC_REG_BASE(fc) + (0x0B10/4))
#define ONFI_FC_ONFI_INTERLEAVED_OP_ATTR_VALUE_SHIFT        (0)
#define ONFI_FC_ONFI_INTERLEAVED_OP_ATTR_VALUE_MASK         (0x000000FF)
#define ONFI_FC_ONFI_INTERLEAVED_OP_ATTR_RESERVED_SHIFT     (8)
#define ONFI_FC_ONFI_INTERLEAVED_OP_ATTR_RESERVED_MASK      (0xFFFFFF00)

#define ONFI_FC_ONFI_SYNC_TIMING_MODE(fc)                   (ONFI_FC_REG_BASE(fc) + (0x0B20/4))
#define ONFI_FC_ONFI_SYNC_TIMING_MODE_VALUE_SHIFT           (0)
#define ONFI_FC_ONFI_SYNC_TIMING_MODE_VALUE_MASK            (0x0000003F)
#define ONFI_FC_ONFI_SYNC_TIMING_MODE_RESERVED_SHIFT        (6)
#define ONFI_FC_ONFI_SYNC_TIMING_MODE_RESERVED_MASK         (0xFFFFFFC0)

#define ONFI_FC_ONFI_SYNC_FEATURES(fc)                      (ONFI_FC_REG_BASE(fc) + (0x0B30/4))
#define ONFI_FC_ONFI_SYNC_FEATURES_VALUE_SHIFT              (0)
#define ONFI_FC_ONFI_SYNC_FEATURES_VALUE_MASK               (0x000000FF)
#define ONFI_FC_ONFI_SYNC_FEATURES_RESERVED_SHIFT           (8)
#define ONFI_FC_ONFI_SYNC_FEATURES_RESERVED_MASK            (0xFFFFFF00)

#define ONFI_FC_ONFI_TCCS(fc)                               (ONFI_FC_REG_BASE(fc) + (0x0B40/4))
#define ONFI_FC_ONFI_TCCS_VALUE_SHIFT                       (0)
#define ONFI_FC_ONFI_TCCS_VALUE_MASK                        (0x000000FF)
#define ONFI_FC_ONFI_TCCS_RESERVED_SHIFT                    (8)
#define ONFI_FC_ONFI_TCCS_RESERVED_MASK                     (0xFFFFFF00)

#define ONFI_FC_SYNC_MODE(fc)                               (ONFI_FC_REG_BASE(fc) + (0x0B50/4))
#define ONFI_FC_SYNC_MODE_VALUE_SHIFT                       (0)
#define ONFI_FC_SYNC_MODE_VALUE_MASK                        (0x00000001)
#define ONFI_FC_SYNC_MODE_RESERVED_SHIFT                    (1)
#define ONFI_FC_SYNC_MODE_RESERVED_MASK                     (0xFFFFFFFE)

#define ONFI_FC_TCAD(fc)                                    (ONFI_FC_REG_BASE(fc) + (0x0B60/4))
#define ONFI_FC_TCAD_VALUE_SHIFT                            (0)
#define ONFI_FC_TCAD_VALUE_MASK                             (0x0000003F)
#define ONFI_FC_TCAD_RESERVED_SHIFT                         (6)
#define ONFI_FC_TCAD_RESERVED_MASK                          (0xFFFFFFC0)

#define ONFI_FC_TCKWR(fc)                                   (ONFI_FC_REG_BASE(fc) + (0x0B70/4))
#define ONFI_FC_TCKWR_VALUE_SHIFT                           (0)
#define ONFI_FC_TCKWR_VALUE_MASK                            (0x0000003F)
#define ONFI_FC_TCKWR_RESERVED_SHIFT                        (6)
#define ONFI_FC_TCKWR_RESERVED_MASK                         (0xFFFFFFC0)

#define ONFI_FC_TCCS(fc)                                    (ONFI_FC_REG_BASE(fc) + (0x0B80/4))
#define ONFI_FC_TCCS_VALUE_SHIFT                            (0)
#define ONFI_FC_TCCS_VALUE_MASK                             (0x0000003F)
#define ONFI_FC_TCCS_RESERVED_SHIFT                         (6)
#define ONFI_FC_TCCS_RESERVED_MASK                          (0xFFFFFFC0)

#define ONFI_FC_PHY_CNTL_REG(fc)                            (ONFI_FC_REG_BASE(fc) + (0x0F00/4))
#define ONFI_FC_PHY_CNTL_REG_EXTENDED_READ_MODE_SHIFT       (0)
#define ONFI_FC_PHY_CNTL_REG_EXTENDED_READ_MODE_MASK        (0x00000001)
#define ONFI_FC_PHY_CNTL_REG_RESERVED_SHIFT                 (1)
#define ONFI_FC_PHY_CNTL_REG_RESERVED_MASK                  (0xFFFFFFFE)

#define ONFI_FC_TOGGLE_CONFIG_REG0(fc)                      (ONFI_FC_REG_BASE(fc) + (0x1200/4))
#define ONFI_FC_TOGGLE_CONFIG_REG0_TOGGLE_MODE_SHIFT        (0)
#define ONFI_FC_TOGGLE_CONFIG_REG0_TOGGLE_MODE_MASK         (0x00000001)
#define ONFI_FC_TOGGLE_CONFIG_REG0_RESERVED0_SHIFT          (1)
#define ONFI_FC_TOGGLE_CONFIG_REG0_RESERVED0_MASK           (0x0000000E)
#define ONFI_FC_TOGGLE_CONFIG_REG0_TCHZ_SHIFT               (4)
#define ONFI_FC_TOGGLE_CONFIG_REG0_TCHZ_MASK                (0x000003F0)
#define ONFI_FC_TOGGLE_CONFIG_REG0_RESERVED1_SHIFT          (10)
#define ONFI_FC_TOGGLE_CONFIG_REG0_RESERVED1_MASK           (0xFFFFFC00)

#define ONFI_FC_TOGGLE_CONFIG_REG1(fc)                      (ONFI_FC_REG_BASE(fc) + (0x1210/4))
#define ONFI_FC_TOGGLE_CONFIG_REG1_TDQSRE_SHIFT             (0)
#define ONFI_FC_TOGGLE_CONFIG_REG1_TDQSRE_MASK              (0x0000003F)
#define ONFI_FC_TOGGLE_CONFIG_REG1_RESERVED_SHIFT           (6)
#define ONFI_FC_TOGGLE_CONFIG_REG1_RESERVED_MASK            (0xFFFFFFC0)

#define ONFI_FC_TOGGLE_REVISION_NUMBER(fc)                  (ONFI_FC_REG_BASE(fc) + (0x1220/4))
#define ONFI_FC_TOGGLE_REV_NUM_VALUE_SHIFT                  (0)
#define ONFI_FC_TOGGLE_REV_NUM_VALUE_MASK                   (0x000000FF)
#define ONFI_FC_TOGGLE_REV_NUM_RESERVED_SHIFT               (8)
#define ONFI_FC_TOGGLE_REV_NUM_RESERVED_MASK                (0xFFFFFF00)

#define ONFI_FC_PHY_CNTL_REG_EXTENDED_READ_MODE_MASK        (0x00000001)

/****************************************************************************
 *
 *   ONFI Flash Phy Registers
 *
 ****************************************************************************/

#define ONFI_FP_PHY_CONFIG0_DP_PSEL_AS_MASK                 (0x0000000C)
#define ONFI_FP_PHY_CONFIG0_DP_PSEL_AS_SHIFT                (2)
#define ONFI_FP_PHY_CONFIG0_READ_LATENCY_AS_MASK            (0x00000700)
#define ONFI_FP_PHY_CONFIG0_READ_LATENCY_AS_SHIFT           (8)

#define ONFI_FP_GATEON_FLASH                                (0x0)
#define ONFI_FP_GATEON_MANUAL                               (0x1)

/****************************************************************************
 *
 *   Timeout Values
 *
 ****************************************************************************/

#define ONFI_DELAY_INTERVAL                     (10)        /*  10 usec */
#define ONFI_RESTORE_TIMEOUT_1_SEC              (1000000)   /*   1 sec  */

#define MO_FC_IDLE_TIMEOUT                      (2000)      /*   2 msec */
#define MO_CMD_TIMEOUT                          (5000)      /*   5 msec */
#define MO_RDDATA_TIMEOUT                       (200000)    /* 200 msec */
#define MO_WRDATA_TIMEOUT                       (200000)    /* 200 msec */

#define FC_RESET_COMPLETE_TIMEOUT               (10000)     /*  10 msec */
#define FC_MAP10_CMD_TIMEOUT                    (2000)      /*   2 msec */
#define FC_MAP01_CMD_TIMEOUT                    (2000)      /*   2 msec */
#define FC_DATA_DMA_TIMEOUT                     (200000)    /* 200 msec */
#define FC_CMD_DMA_TIMEOUT                      (200000)    /* 200 msec */
#define FC_L3_CACHE_FLUSH_TIMEOUT               (2000)      /*   2 msec */
#define FC_DMA_ENABLE_TIMEOUT                   (2000)      /*   2 msec */

/* ONFI Sub Feature parameters for setting of interface timing mode */
typedef volatile struct _ONFI_SUBFEATURE_TIMINGMODE
{
#if defined( __BIG_ENDIAN__ ) || defined( __BIG_ENDIAN )
    U32                 Reserved4       : 8;
    U32                 Reserved3       : 8;
    U32                 Reserved2       : 8;
    U32                 Reserved1       : 2;
    ONFI_INTERFACE_MODE InterfaceMode   : 2;
    U32                 TimingMode      : 4;
#else
    U32                 TimingMode      : 4;
    ONFI_INTERFACE_MODE InterfaceMode   : 2;
    U32                 Reserved1       : 2;
    U32                 Reserved2       : 8;
    U32                 Reserved3       : 8;
    U32                 Reserved4       : 8;
#endif
} ONFI_SUBFEATURE_TIMINGMODE;

/****************************************************************************
 *
 *   MAP Command Structures
 *
 ****************************************************************************/

typedef enum _MAP_TYPE
{
    MAP00 = 0x0,
    MAP01 = 0x1,
    MAP10 = 0x2,
    MAP11 = 0x3

} MAP_TYPE;

typedef struct _MAP00_CMD_ADDR
{
#if defined( __BIG_ENDIAN__ ) || defined( __BIG_ENDIAN )
    U32         ReadCyc          : 1;
    U32         Reserved4        : 1;
    U32         TwoBeatDataPhase : 1;
    U32         Reserved3        : 1;
    MAP_TYPE    MapType          : 2;
    U32         BankSel          : 2;
    U32         Reserved2        :11;
    U32         BuffAddr         :11; /* Max page size is 8K (requires 13 bits) */
    U32         Reserved1        : 2; /* Lower 2 bits are ignored to align to 4 bytes */
#else
    U32         Reserved1        : 2; /* Lower 2 bits are ignored to align to 4 bytes */
    U32         BuffAddr         :11; /* Max page size is 8K (requires 13 bits) */
    U32         Reserved2        :11;
    U32         BankSel          : 2;
    MAP_TYPE    MapType          : 2;
    U32         Reserved3        : 1;
    U32         TwoBeatDataPhase : 1;
    U32         Reserved4        : 1;
    U32         ReadCyc          : 1;
#endif
} MAP00_CMD_ADDR;

typedef struct _MAP01_CMD_ADDR
{
#if defined( __BIG_ENDIAN__ ) || defined( __BIG_ENDIAN )
    U32         ReadCyc          : 1;
    U32         Reserved3        : 1;
    U32         TwoBeatDataPhase : 1;
    U32         Reserved2        : 1;
    MAP_TYPE    MapType          : 2;
    U32         BankSel          : 2;
    U32         BlockPageAddr    :22;
    U32         Reserved1        : 2; /* Lower 2 bits are ignored to align to 4 bytes */
#else
    U32         Reserved1        : 2; /* Lower 2 bits are ignored to align to 4 bytes */
    U32         BlockPageAddr    :22;
    U32         BankSel          : 2;
    MAP_TYPE    MapType          : 2;
    U32         Reserved2        : 1;
    U32         TwoBeatDataPhase : 1;
    U32         Reserved3        : 1;
    U32         ReadCyc          : 1;
#endif
} MAP01_CMD_ADDR;

typedef struct _MAP10_CMD_ADDR
{
#if defined( __BIG_ENDIAN__ ) || defined( __BIG_ENDIAN )
    U32         Reserved3          : 1;
    U32         FourBeatDataPhase  : 1;
    U32         Reserved2          : 2;
    MAP_TYPE    MapType            : 2;
    U32         BankSel            : 2;
    U32         BlockPageAddr      :22;
    U32         Reserved1          : 2; /* Lower 2 bits are ignored to align to 4 bytes */
#else
    U32         Reserved1          : 2; /* Lower 2 bits are ignored to align to 4 bytes */
    U32         BlockPageAddr      :22;
    U32         BankSel            : 2;
    MAP_TYPE    MapType            : 2;
    U32         Reserved2          : 2;
    U32         FourBeatDataPhase  : 1;
    U32         Reserved3          : 1;
#endif
} MAP10_CMD_ADDR;

/* 10 bit MAP10 DMA Type */
typedef enum _MAP10_DMA_TYPE
{
    MAP10_DMA_TYPE_CMD     = 0x2,
    MAP10_DMA_TYPE_RESET   = 0x3

} MAP10_DMA_TYPE;

typedef struct _MAP10_CMD_DATADMA_DATA
{
#if defined( __BIG_ENDIAN__ ) || defined( __BIG_ENDIAN )
    U32         Reserved1   : 7;
    U32         GenerateInt : 1;
    U32         BurstLength : 8;
    U32         DMAType     : 4; /* MAP10_DMA_TYPE */
    U32         Write       : 4; /* 0 - Read, 1 - Write */
    U32         PageCount   : 8;
#else
    U32         PageCount   : 8;
    U32         Write       : 4; /* 0 - Read, 1 - Write */
    U32         DMAType     : 4; /* MAP10_DMA_TYPE */
    U32         BurstLength : 8;
    U32         GenerateInt : 1;
    U32         Reserved1   : 7;
#endif
    U32         AddressLo;
    U32         AddressHi;
    U32         Reserved2;

} MAP10_CMD_DATADMA_DATA;

typedef struct _MAP10_CMD_CMDDMA_DATA
{
#if defined( __BIG_ENDIAN__ ) || defined( __BIG_ENDIAN )
    U32 Reserved1   :16;
    U32 DMAType     :10; /* MAP10_DMA_TYPE */
    U32 DMAChannel  : 6; /* ChannelNumber or memcopy */
#else
    U32 DMAChannel  : 6; /* ChannelNumber or memcopy */
    U32 DMAType     :10; /* MAP10_DMA_TYPE */
    U32 Reserved1   :16;
#endif
    U32 AddressLo;
    U32 AddressHi;
    U32 Reserved2;

} MAP10_CMD_CMDDMA_DATA;

/* 2 bit MAP 11 cycle type */
typedef enum _MAP11_CYCLE_TYPE
{
    CYCLE_CMD   = 0x0,
    CYCLE_ADDR  = 0x1,
    CYCLE_DATA  = 0x2

} MAP11_CYCLE_TYPE;

typedef struct _MAP11_CMD_ADDR
{
#if defined( __BIG_ENDIAN__ ) || defined( __BIG_ENDIAN )
    U32              ReadCyc          : 1;
    U32              Reserved4        : 1;
    U32              TwoBeatDataPhase : 1;
    U32              Reserved3        : 1;
    MAP_TYPE         MapType          : 2;
    U32              BankSel          : 2;
    U32              Reserved2        :20;
    MAP11_CYCLE_TYPE CycleType        : 2;
    U32              Reserved1        : 2;
#else
    U32              Reserved1        : 2;
    MAP11_CYCLE_TYPE CycleType        : 2;
    U32              Reserved2        :20;
    U32              BankSel          : 2;
    MAP_TYPE         MapType          : 2;
    U32              Reserved3        : 1;
    U32              TwoBeatDataPhase : 1;
    U32              Reserved4        : 1;
    U32              ReadCyc          : 1;
#endif
} MAP11_CMD_ADDR;

/* 32 Bit ONFI Standard Command Codes Byte0= 1stCycleCommand, Byte1= 2ndCycleCommand */
typedef enum _ONFI_CMD
{
    ONFI_CMD_READ                           = 0x00003000,
    ONFI_CMD_READ_INTERLEAVED               = 0x00003200,
    ONFI_CMD_READ_COPYBACK                  = 0x00003500,
    ONFI_CMD_CHANGE_READ_COL                = 0x0000e005,
    ONFI_CMD_CHANGE_READ_COL_ENHANCED       = 0x0000e006,
    ONFI_CMD_READ_CACHE_RANDOM              = 0x00003100,
    ONFI_CMD_READ_CACHE_SEQ                 = 0x00000031,
    ONFI_CMD_READ_CACHE_END                 = 0x0000003f,
    ONFI_CMD_BLOCK_ERASE                    = 0x0000d060,
    ONFI_CMD_BLOCK_ERASE_INTERLEAVED        = 0x0000d160,
    ONFI_CMD_READ_STATUS                    = 0x00000070,
    ONFI_CMD_READ_STATUS_ENHANCED           = 0x00000078,
    ONFI_CMD_PAGE_PROGRAM                   = 0x00001080,
    ONFI_CMD_PAGE_PROGRAM_INTERLEAVED       = 0x00001180,
    ONFI_CMD_PAGE_PROGRAM_CACHED            = 0x00001580,
    ONFI_CMD_COPYBACK_PROGRAM               = 0x00001085,
    ONFI_CMD_COPYBACK_PROGRAM_INTERLEAVED   = 0x00001185,
    // ONFI_CMD_SMALL_DATA_MOVE             = 0x00001185, value not unique in ONFI 2.1 standard
    ONFI_CMD_CHANGE_WRITE_COL               = 0x00000085,
    // ONFI_CMD_CHANGE_ROW_ADDR             = 0x00000085, value not unique in ONFI 2.1 standard
    ONFI_CMD_READ_ID                        = 0x00000090,
    ONFI_CMD_READ_PARAM_PAGE                = 0x000000ec,
    ONFI_CMD_READ_UNIQUE_ID                 = 0x000000ed,
    ONFI_CMD_GET_FEATUTES                   = 0x000000ee,
    ONFI_CMD_SET_FEATURES                   = 0x000000ef,
    ONFI_CMD_SYNCHRONOUS_RESET              = 0x000000fc,
    ONFI_CMD_DEVICE_RESET                   = 0x000000ff

} ONFI_CMD;

/* 8 Bit ONFI Feature Address for Set/Get feature command */
typedef enum _ONFI_FEATURE_ADDR
{
    ONFI_FEATURE_ADDR_TIMINGMODE            = 0x01,
    ONFI_FEATURE_ADDR_IO_DRIVE_STRENGTH     = 0x10

} ONFI_FEATURE_ADDR;

typedef enum _ONFI_ECC
{
    ECC_DISABLE     = 0x0,
    ECC_ENABLE      = 0x1

} ONFI_ECC;

typedef enum _ONFI_DMA
{
    DMA_DISABLE     = 0x0,
    DMA_ENABLE      = 0x1

} ONFI_DMA;

typedef enum _ONFI_TRANSFER_MODE
{
    TRANSFER_MODE_DEFAULT         =   0x00,
    TRANSFER_MODE_SPARE           =   0x01,
    TRANSFER_MODE_MAIN_SPARE      =   0x02

} ONFI_TRANSFER_MODE;

typedef enum _ONFI_BEAT_MODE
{
    BEAT_MODE_DEFAULT = 0x0,
    BEAT_MODE_TWO     = 0x2,
    BEAT_MODE_FOUR    = 0x4

} ONFI_BEAT_MODE;

typedef struct _ONFI_MAP_COMMAND_OPTION
{
    ONFI_ECC            Ecc;
    ONFI_DMA            Dma;
    ONFI_TRANSFER_MODE  TransferMode;
    ONFI_BEAT_MODE      BeatMode;

} ONFI_MAP_COMMAND_OPTION, *PTR_ONFI_MAP_COMMAND_OPTION;

typedef enum _MAP_CMD
{
    MAP00_READ                        = 0x0002,
    MAP00_WRITE                       = 0x0003,

    MAP01_READ                        = 0x0004,
    MAP01_WRITE                       = 0x0005,

    MAP10_SET_ERASE_BLOCK             = 0x0001,
    MAP10_SET_UNLOCK_START_ADDR       = 0x0010,
    MAP10_SET_UNLOCK_END_GO           = 0x0011,
    MAP10_INITIATE_LOCK_ALL           = 0x0021,
    MAP10_INITIATE_LOCKTIGHT_ALL      = 0x0031,
    MAP10_ENABLE_SPAREONLY_ACCESS     = 0x0041,
    MAP10_ENABLE_DEFAULT_ACCESS       = 0x0042,
    MAP10_ENABLE_MAIN_SPARE_ACCESS    = 0x0043,
    MAP10_LOAD_PAGE_REGISTER          = 0x0060,
    MAP10_SET_PAGE_DESTINATION        = 0x0061,
    MAP10_STORE_PAGE_REGISTER         = 0x0062,
    MAP10_SET_COPY_SRC_ADDR           = 0x1000,
    MAP10_SET_COPY_DST_ADDR_GO        = 0x1100,  /* 'or' with value PP[7:0] defining number of pages */
    MAP10_SET_PIPELINE_ACCESS_READ    = 0x2000,  /* 'or' with value PP[7:0] defining number of pages */
    MAP10_SET_PIPELINE_ACCESS_WRITE   = 0x2100   /* 'or' with value PP[7:0] defining number of pages */

} MAP_CMD;

typedef struct _ONFI_MAP_COMMAND
{
    MAP_TYPE                MapType;
    MAP_CMD                 MapCommand;
    ONFI_MAP_COMMAND_OPTION CommandOption;
    U32                     MoRegAddr;
    U32                     MoIntr;
    U32                     FcRegAddr;
    U32                     FcIntr;

} ONFI_MAP_COMMAND, *PTR_ONFI_MAP_COMMAND;

#define MAX_ONFI_MAP_COMMAND   (11)

static const ONFI_MAP_COMMAND onfiMapCmd[MAX_ONFI_MAP_COMMAND] =
{
    /* MapType, MapCommand,                 {ECC, DMA, Transfer Mode, Beat Mode},                                 MO Reg Addr,     MO Intr,                                        FC Reg Addr, FC Intr */
    {MAP00, MAP00_READ,                     {ECC_DISABLE, DMA_DISABLE, TRANSFER_MODE_DEFAULT, BEAT_MODE_TWO},     MSS_MO_INT_STAT, MSS_MO_INT_STAT_FC0_RDDATA_FULL_INT_STAT_MASK,  0, 0},
    {MAP00, MAP00_WRITE,                    {ECC_DISABLE, DMA_DISABLE, TRANSFER_MODE_DEFAULT, BEAT_MODE_TWO},     MSS_MO_INT_STAT, MSS_MO_INT_STAT_FC0_WRDATA_EMPTY_INT_STAT_MASK, 0, 0},

    {MAP01, MAP01_READ,                     {ECC_DISABLE, DMA_DISABLE, TRANSFER_MODE_DEFAULT, BEAT_MODE_TWO},     MSS_MO_INT_STAT, MSS_MO_INT_STAT_FC0_RDDATA_FULL_INT_STAT_MASK,  0, ONFI_FC_INTR_STATUS_PAGE_XFER_INC0_MASK},
    {MAP01, MAP01_WRITE,                    {ECC_DISABLE, DMA_DISABLE, TRANSFER_MODE_DEFAULT, BEAT_MODE_TWO},     MSS_MO_INT_STAT, MSS_MO_INT_STAT_FC0_WRDATA_EMPTY_INT_STAT_MASK, 0, ONFI_FC_INTR_STATUS_PAGE_XFER_INC0_MASK},

    {MAP10, MAP10_SET_ERASE_BLOCK,          {ECC_DISABLE, DMA_DISABLE, TRANSFER_MODE_DEFAULT, BEAT_MODE_DEFAULT}, MSS_MO_INT_STAT, MSS_MO_INT_STAT_FC0_CMD_DONE_INT_STAT_MASK,     0, ONFI_FC_INTR_STATUS_ERASE_COMP0_MASK},
    {MAP10, MAP10_LOAD_PAGE_REGISTER,       {ECC_DISABLE, DMA_DISABLE, TRANSFER_MODE_DEFAULT, BEAT_MODE_DEFAULT}, MSS_MO_INT_STAT, MSS_MO_INT_STAT_FC0_CMD_DONE_INT_STAT_MASK,     0, ONFI_FC_INTR_STATUS_LOAD_COMP0_MASK},
    {MAP10, MAP10_SET_PAGE_DESTINATION,     {ECC_DISABLE, DMA_DISABLE, TRANSFER_MODE_DEFAULT, BEAT_MODE_DEFAULT}, MSS_MO_INT_STAT, MSS_MO_INT_STAT_FC0_CMD_DONE_INT_STAT_MASK,     0, 0},
    {MAP10, MAP10_STORE_PAGE_REGISTER,      {ECC_DISABLE, DMA_DISABLE, TRANSFER_MODE_DEFAULT, BEAT_MODE_DEFAULT}, MSS_MO_INT_STAT, MSS_MO_INT_STAT_FC0_CMD_DONE_INT_STAT_MASK,     0, ONFI_FC_INTR_STATUS_PROGRAM_COMP0_MASK},
    {MAP10, MAP10_ENABLE_DEFAULT_ACCESS,    {ECC_DISABLE, DMA_DISABLE, TRANSFER_MODE_DEFAULT, BEAT_MODE_DEFAULT}, MSS_MO_INT_STAT, MSS_MO_INT_STAT_FC0_CMD_DONE_INT_STAT_MASK,     0, 0},
    {MAP10, MAP10_ENABLE_SPAREONLY_ACCESS,  {ECC_DISABLE, DMA_DISABLE, TRANSFER_MODE_DEFAULT, BEAT_MODE_DEFAULT}, MSS_MO_INT_STAT, MSS_MO_INT_STAT_FC0_CMD_DONE_INT_STAT_MASK,     0, 0},
    {MAP10, MAP10_ENABLE_MAIN_SPARE_ACCESS, {ECC_DISABLE, DMA_DISABLE, TRANSFER_MODE_DEFAULT, BEAT_MODE_DEFAULT}, MSS_MO_INT_STAT, MSS_MO_INT_STAT_FC0_CMD_DONE_INT_STAT_MASK,     0, 0}
};

#define BLOCK_PAGE_ADDRESS(ChannelIndex, BlockAddr, PageAddr) (((BlockAddr) << gOnfiDeviceInfo[(ChannelIndex)].PageAddrBits) | \
                                                               ((PageAddr) & gOnfiDeviceInfo[(ChannelIndex)].PageAddrMask))

#define CALCULATE_TICKS(X, Y)   ((X / Y) + ((X % Y) ? 1 : 0))

#endif
